/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/BidiUtil", [], function(){
	
	function isBidiChar(c){
		if (c >= 0x05d0 && c <= 0x05ff ||
			c >= 0x0600 && c <= 0x065f ||
		    c >= 0x06fa && c <= 0x07ff ||
		    c >= 0xfb50 && c <= 0xfdff ||
		    c >= 0xfe70 && c <= 0xfefc)
		     return true;
		else
		     return false;
		};

	function isLatinChar(c){
		if((c > 64 && c < 91)||(c > 96 && c < 123))
			return true;
		else            
		    return false;    
	};
	
	bidiUtil = {
		LRE: "\u202A", //"&#8234;";
		RLE: "\u202B", //"&#8235;";
		PDF: "\u202C", //"&#8236;";
		LRM: "\u200E", //"&#8206;";
    	RLM: "\u200F", //"&#8207;";
    	
    	GREGORIAN_DATE_MARK : "G",
    	BUDDHIST_DATE_MARK: "B",
    	HEBREW_DATE_MARK: "H",
    	ISLAMIC_DATE_MARK: "I",
	
		getResolvedDir: function(text,textDir,defDir){
		   if (textDir != "auto"){
			   return textDir;
		   }
		   var len = text.length;
		   for(var i = 0;i < len;i++)  {
		      symbol = text.charCodeAt(i);
		      if(isBidiChar(symbol))
		         return "rtl";
		      else if(isLatinChar(symbol))
		         return "ltr";
		   }
		   return defDir;			
		},
		
		getFormattedText: function(text,textDir,defDir){
			if (textDir == "auto"){
				textDir = this.getResolvedDir(text,textDir,defDir);
			}
			return (textDir == "rtl"? this.RLE : this.LRE) + text + this.PDF;
		},
		
		isGregorian: function(sign){
			if (!sign || sign == this.GREGORIAN_DATE_MARK){
				return true;
			}
			return false;
		},
		
		getNationalDatePackage: function(sign){
			var pack = {};
			var path = sign == this.BUDDHIST_DATE_MARK? "dojox/date/buddhist" : (sign == this.HEBREW_DATE_MARK? "dojox/date/hebrew" : (sign == this.ISLAMIC_DATE_MARK? "dojox/date/islamic" : null));
			if (path){
					require([path,path+"/locale"], function(path){
						pack.pack = path;						
					});
					pack.name = path.replace(/\//g,".");
			}
			return pack;
		}
		
	};
	return bidiUtil;	
});
