// wrapped by build app
define("dojoe/Util", ["dijit","dojo","dojox"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("dojoe.Util");

/*Common utility functions for all*/

isNumber = function(value){
	return (typeof value === 'number' && isFinite(value));
}

startsWith = function(all, part){
	return (all.indexOf(part) === 0);
}

endsWith = function(all, part){
	return (all.lastIndexOf(part) === all.length - part.length);
}

contains = function(all, part){
	return (all.lastIndexOf(part) >= 0);
}

trim = function(stringToTrim) {
	if(!stringToTrim) return stringToTrim;
	return stringToTrim.replace(/^\s+|\s+$/g,"");
}

ltrim = function(stringToTrim) {
	if(!stringToTrim) return stringToTrim;
	return stringToTrim.replace(/^\s+/,"");
}

rtrim = function(stringToTrim) {
	if(!stringToTrim) return stringToTrim;
	return stringToTrim.replace(/\s+$/,"");
}

stripTags = function(value) {
	if(!value) return value;
	return value.replace(/<\/?[^>]+>/gi, '');
}

escapeHTML = function(value) {
	/*var div = document.createElement('div');
	var text = document.createTextNode(value);
	div.appendChild(text);
	return div.innerHTML;*/
	//Above implementation doesn't remove '
	//Bobby: 24Oct2012, returns null string if value is undefined, so just return it
	if(!value) return value;
	return String(value)
		.replace(/&/g, '&amp;')
		.replace(/"/g, '&quot;')
		.replace(/'/g, '&#39;')
		.replace(/</g, '&lt;')
		.replace(/>/g, '&gt;');
}

escapeSpecialCharacters = function(value) {
	return String(value)
			.replace(/%/g, '%25')
			.replace(/&/g, '%26')
			.replace(/</g, '%3C')
			.replace(/>/g, '%3E');
}

unescapeHTML = function(value) {
	/*var div = document.createElement('div');
	div.innerHTML = stripTags(value);
	return div.childNodes[0].nodeValue;*/
	
	if(!value) return value;
	return String(value)
		.replace(/&amp;/g, '&')
		.replace(/&quot;/g, '"')
		.replace(/&#39;/g, "'")
		.replace(/&lt;/g, '<')
		.replace(/&gt;/g, '>');
}


});
