require({cache:{
'url:dojoe/gauge/valuestatus/templates/ValueStatusGauge.html':"<div id=\"${id}_valueStatusGauge\">\r\n\t<table role=\"presentation\" align=\"center\" style='table-layout:fixed' data-dojo-attach-point=\"table\" cellpadding=\"0px\" cellspacing=\"0px\">\r\n\t\t<tr>\r\n\t\t\t<td colspan=\"2\" data-dojo-attach-point=\"topLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" id=\"${id}_topLabel\" class=\"dojoxEllipsis\" align=\"center\" data-dojo-attach-point=\"topLabelDiv\" style=\"text-overflow: ellipsis\">\r\n\t\t\t\t</div>\r\n\t\t\t</td>\t\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td data-dojo-attach-point=\"leftLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" class=\"dojoxEllipsis\" id=\"${id}_leftLabel\" data-dojo-attach-point=\"leftLabelDiv\" style=\"text-overflow: ellipsis;text-align:right\">\t\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t\t<td data-dojo-attach-point=\"valueStatusGaugeTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div id=\"${id}_valueStatusGaugeDiv\" align=\"center\" data-dojo-attach-point=\"valueStatusGaugeDiv\" style=\"align:left\" >\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t</table>\r\n</div>\r\n"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/gauge/valuestatus/ValueStatusGauge",[
		"dojo/_base/declare",
		"dojo/_base/connect",
		"dijit/_WidgetBase",
		"dijit/_TemplatedMixin",
		"dojo/text!./templates/ValueStatusGauge.html",
		"dojoe/BidiUtil",
		"dojoe/gauge/valuestatus/ValueStatusStyle",
		"dojoe/gauge/common/AbstractGauge",
		"dijit/Tooltip",
		"dojo/i18n!./../common/nls/Gauge",
		"dojo/colors"
	],function(declare, connect, _WidgetBase, _TemplatedMixin, template, bidiUtil, ValueStyle, AbstractGauge, Tooltip, nlsBundle, colors) {
		return declare("dojoe.gauge.valuestatus.ValueStatusGauge", [_WidgetBase, _TemplatedMixin], {

		templateString: template,
		valueStatusGauge:null,
		
		// width: number  
		//		Holds the width of the Value Status Gauge. 
		width:100,
		
		// height: number  
		//		Holds the height of the Value Status Gauge. 
		height:100,
		
		// topLabel: String  
		//		Holds the String/label to be displayed on top of the Value Status Gauge
		topLabel:"",
		
		// leftLabel: String  
		//		Holds the String/label to be displayed on the leading edge the Value Status Gauge
		leftLabel:"",
		
		// value: Numeric  
		//		Holds the numeric value which the Value Status Gauge should represent.
		value:0,
		
		// value: Boolean  
		//		Holds a boolean value to indicate if the gauge is supposed to have a top label at any point
		topLabelPresent: false,
		
		// value: Boolean  
		//		Holds a boolean value to indicate if the gauge is supposed to have a leading edge label at any point
		leftLabelPresent: false,
		
		// value: String
		//		Holds a default state to be displayed when dataset is empty.
		defaultStatus: "Unknown",
		
		// value: String
		//		Font Size of the labels
		fontSize:"",
		
		// value: String
		//		Font Family of the labels
		fontFamily:"",
		
		// value: String
		//		Font Color of the labels
		fontColor:"",
		
		_labelRatio:0.25,
		_size:0,
		_labelSet:false,
		_textHeight : 15,
		nls: nlsBundle,
		
		constructor: function() {
			dojo.mixin(this, arguments);
			
		},
		
		postCreate: function() {
			if(this.topLabelPresent) {
				this.topLabelDiv.innerHTML = ".";
			}
				
			if(this.fontFamily !== "") {
				this.leftLabelDiv.style.fontFamily = this.fontFamily; 
				this.topLabelDiv.style.fontFamily = this.fontFamily;
			}
			
			if(this.fontSize !== "") {
				this.leftLabelDiv.style.fontSize = this.fontSize; 
				this.topLabelDiv.style.fontSize = this.fontSize;
				switch(this.fontSize) {
					case "xx-small":
					case "x-small":
					case "small":
						this.topLabelDiv.style.paddingBottom = "2px";
						break;
					case "medium":
						this.topLabelDiv.style.paddingBottom = "4px";
						break;
					case "xx-large":
					case "x-large":
					case "large":
						this.topLabelDiv.style.paddingBottom = "6px";
						break;
				}
			}
			
			if(this.fontColor != "" && this.fontColor !== "Default") {
				this.fontColor = this.fontColor.replace(/\s+/g, '');
				this.leftLabelDiv.style.color = dojo.colorFromString(this.fontColor).toHex(); 
				this.topLabelDiv.style.color = dojo.colorFromString(this.fontColor).toHex();
			}
			
			if(this.leftLabelPresent) {
				this._labelRatio = 0.25;
				this.leftLabelTD.style.width = (this.domNode.offsetWidth * 0.25) + "px";
				this.leftLabelDiv.style.width= (this.domNode.offsetWidth * 0.25) + "px";
				this.leftLabelDiv.style.marginRight = "0px";
				if(this.leftLabel){
					this.leftLabelDiv.innerHTML = this.leftLabel;
					this.leftLabelDiv.title = this.leftLabel;
				}
				if(this.dir == "rtl")
					this.leftLabelDiv.style.marginLeft="8px";
				else
					this.leftLabelDiv.style.marginRight="8px";
			} else {
				this._labelRatio = 0;	
			}
			this.valueStatusGauge = new dojoe.gauge.common.AbstractGauge({thresholds:this.thresholds, _currentValue:this._currentValue, dir:this.dir, styler:new ValueStyle()}, this.valueStatusGaugeTD.children[0]); //def58992
			//this.valueStatusGauge.styler = new ValueStyle();
			this.valueStatusGauge.styler.orient = this.valueStatusGauge.dir; //def58992
			this.valueStatusGauge.startup();
			this._textHeight = this.topLabelTD.clientHeight;
			this.topLabelDiv.innerHTML = "";
			if(this.topLabel) {
				this.topLabelDiv.innerHTML = this.topLabel;
				this.topLabelDiv.title = this.topLabel;
			}
			if(!this.leftLabelPresent) {
				console.debug(this.valueStatusGauge.domNode);
				this.valueStatusGauge.domNode.style.margin = "auto";
			}
			var leftLabelTooltip = dojo.hitch( this, this._showTooltip, "left" ); 			
			var topLabelTooltip = dojo.hitch( this, this._showTooltip, "top" ); 			
			this.connect(this.leftLabelDiv, "onclick", this, leftLabelTooltip);
			this.connect(this.topLabelDiv, "onclick", this, topLabelTooltip);
			this.valueStatusGauge.domNode.tabIndex = "0";
			this.leftLabelDiv.style.textOverflow="ellipsis";
			this.topLabelDiv.style.textOverflow="ellipsis";
			dojo.attr(this.valueStatusGauge.domNode, "role", "button");
			this.inherited(arguments);
		},
		

		startup: function() {
			try{
				this.inherited(arguments);	
			}catch(err){
				console.debug(err);
			}
			
		},
		
		_showTooltip : function(arg) {
			var node;
			if(arg == "left"){
				node = this.leftLabelDiv;
				Tooltip.show(this.leftLabel, node, ['above-centered','below-centered','after']);
			} else {
				node = this.topLabelDiv;
				Tooltip.show(this.topLabel, node, ['above-centered','below-centered','after']);
			}			
			setTimeout(function(){
				Tooltip.hide(node);
			}, 2000);
		},
		
		draw: function(surface){
			this.valueStatusGauge.adjust(surface);
		},
		
		resize: function(size){
			// summary:  
			//		Resizes the Value Status Gauge
			// sx: number
			//		 Ratio of original width and new width available
			// sy: number 
			//		Ratio of original Height and new height available
			// px: number 
			//		New width available
			// py: number 
			//		New height available
			// Do not add metric while specifying the numbers above
			// tags: public
			var px = size.available.w;
			var py = size.available.h;
			
			if(this.width == px && this.height == py) // same dimensions, no need to resize again.
				return;
			
			//52965
			//this.width = this.width * sx;
			//this.height = this.height * sy;
			this.leftLabelTD.style.width = (px * this._labelRatio) + "px";
			this.leftLabelDiv.style.width=(px * this._labelRatio) + "px";
			this.width = px;
			this.height = py;
			var gfxWidth = px - this.leftLabelTD.offsetWidth - 4;
			if(this.leftLabelPresent)
				gfxWidth = gfxWidth - 10;
			var gfxHeight = py - this._textHeight - 4;
			var min = gfxWidth < gfxHeight?gfxWidth:gfxHeight;
			//this.valueStatusGaugeDiv.style.width = this._size + "px";
			this.valueStatusGaugeDiv.style.position = "relative";
			this.valueStatusGauge._adjust({
				width:min, 
				height:min
			});
			this.topLabelTD.style.width = this.width - 4 + "px"; 
			this.topLabelDiv.style.width= this.width - 4 + "px"; 
			this.topLabelDiv.style.whiteSpace="nowrap";
			//this.leftLabelTD.style.height = this._size + "px";
			if (this.dir == "rtl"){                                                                 //def58992
				    //40110: [BIDI Languages only] Gauges, Top label positioning is incorrect for bi-di languages.
					this.topLabelDiv.style.marginRight = this.leftLabelDiv.offsetWidth + "px";
					this.topLabelDiv.style.marginLeft = "0px";
			} 
			if(this.leftLabelPresent){                                                                                //def58992
				this.topLabelTD.style.width=min + "px";
				this.topLabelDiv.style.width=min + "px";
				if(this.dir != "rtl")
					this.topLabelDiv.style.marginLeft = this.leftLabelDiv.offsetWidth + "px";
			} 
			//this.table.style.marginTop = (py- this.table.offsetHeight)/2 + "px"; // 52965
		},
		
		setLabelAndValue: function(topLabel, leftLabel, value) {
			// summary:  
			//		Sets labels and value for the Value Status Gauge
			// topLabel: String
			//		 Label which appears at the TOP of the gauge
			// leftLabel: String 
			//		Label which appears on the leading edge of the gauge
			// value: Numeric 
			//		Numeric Value to be displayed on the gauge
			// tags: public
			/*LS - avoid calling data apis in widget on object references
	    	 * 58511: TBSM 36702: Perf: Memory Leak in TWL status gauge*/
			/*if(topLabel && typeof(topLabel.getValueType) != "undefined" && topLabel.getValueType() == "status") {
				this.topLabel = topLabel.getValue().getValue();
			} else if(topLabel && typeof(topLabel.getValue) != "undefined") {
				this.topLabel = topLabel.getValue();
			} else
				this.topLabel = topLabel;
				
			if(leftLabel && typeof(leftLabel.getValueType) != "undefined" && leftLabel.getValueType()=="status")
				this.leftLabel = leftLabel.getValue().getValue();
			else if(leftLabel && typeof(leftLabel.getValue) != "undefined") {
				this.leftLabel = leftLabel.getValue();
			}else
				this.leftLabel = leftLabel;*/
				
			if(topLabel != "undefined" && topLabel != null) {
				this.topLabelDiv.innerHTML = topLabel;
				this.topLabelDiv.title = topLabel;
				this.topLabel = topLabel;
			}
	    	if(leftLabel != "undefined" && leftLabel != null)  {
				this.leftLabelDiv.innerHTML = leftLabel;
				this.leftLabelDiv.title = leftLabel;
				this.leftLabel = leftLabel;
			}
	    	
	    	if(value && typeof value.getValue == 'function')
				value = value.getValue();
			
			this.setValue(value);		
		},
		
		setValue: function(/*number*/ value){	
			if(value != "undefined" && value != null) this.value = value;

			if(value && typeof value.getValue == 'function')
				value = value.getValue();
				
			if(value == null)
				value = this.valueStatusGauge.errorStatus;
				
			this.valueStatusGauge.setValue(value);
			var title="";
			if(isNaN(value))
				title = dojo.string.substitute(this.nls.GAUGE_STATUS, { 0: this.valueStatusGauge.styler.getStatus()});
			else
				title = dojo.string.substitute(this.nls.GAUGE_VALUE_STATUS, { 0: value, 1: this.valueStatusGauge.styler.getStatus()});
				
			this.valueStatusGauge.domNode.title = title;
			// 78557: Accessibility: JAWS does not read the value from Value Status Gauge 
			// 78557 is no longer an issue with new JAWS. New RPT plugin policy reports an exception for below attr
			// dojo.attr(this.valueStatusGauge.domNode, "aria-labelledby", title);
		},
	
		clearLabels: function() {
			this.leftLabelDiv.innerHTML = "";
			this.topLabelDiv.innerHTML = "";
		},
		
		destroy: function(){
			// summary:
			//          Called when the widget is destroyed by dojo, used to clean 
			//          up memory before disassociating the widget from the dom.
			/*this.destroyWidgets();
			if(dojo.byId(this.id+"valueStatusGaugeDiv")) 
				dojo.forEach(dijit.findWidgets(dojo.byId(this.id+"valueStatusGaugeDiv")), function(widget){
				// Avoid double destroy of widgets like Menu that are attached to body
				// even though they are logically children of other widgets.
				if(widget && !widget._destroyed){
					if(widget.destroyRecursive){
						widget.destroyRecursive();
					}else if(widget.destroy){
						widget.destroy();
					}
				}
			});	*/
			this.topLabel= null;
			this.leftLabel=null;
			this.value=null;
			this.inherited(arguments);
		}
		
	/*	destroyWidgets: function() {
			try{
				if(this.gauge){
					var listWidget = dojo.byId(this.gauge);
					if(listWidget.destroyRecursive) listWidget.destroyRecursive();
					else if(listWidget.destroy) listWidget.destroy();
				}	
				
			} catch (ex) {
				console.error ("ValueStatusGauge.js: Caught exception in destroy:");
				console.error (ex);
			}
		}*/
	});
});
