require({cache:{
'url:dojoe/ssd/quickedit/templates/GroupWidgetOptions.html':"<div style=\"height:100%;width:100%;\"> \r\n\t<div data-dojo-attach-point=\"groupWidgetOptionsNode\"></div>\t\r\n</div>\t"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/ssd/quickedit/GroupWidgetOptions", [
	"dojo/parser",
	"dojo/_base/declare",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/i18n!./nls/GroupWidgetOptions",
	"dijit/_WidgetsInTemplateMixin",
	"dojo/text!./templates/GroupWidgetOptions.html",
	"dijit/layout/BorderContainer", 
	"dijit/layout/ContentPane", 
	"ibm/tivoli/tip/dijit/DndListbox",
	"dojo/store/Memory",
	"dijit/form/ComboBox",
	"dijit/form/FilteringSelect",
	"dijit/form/Button",
	"dojo/_base/connect",
	"dojoe/ssd/quickedit/DatasetDetails",
	"dojoe/tablelayout/TableLayout",
	"dijit/form/TextBox",
	"dijit/form/NumberSpinner",
	"dijit/form/NumberTextBox",
	"dijit/form/CheckBox",
	"dojo/domReady!"
	], function (parser, declare, _WidgetBase, _TemplatedMixin, nlsBundle, _WidgetsInTemplateMixin, template, BorderContainer, ContentPane, DndListbox, Memory, ComboBox, FilteringSelect, Button, Connect, DatasetDetails, TableLayout, TextBox, NumberSpinner, NumberTextBox, CheckBox) {
	
	  return declare("dojoe.ssd.quickedit.GroupWidgetOptions", [_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], {
	 
		templateString: template,
		nls: nlsBundle,
		dndListBox : null,
		filteringSelect: null,
		optionsGrid_data: null,
		
		constructor: function (args) {
			console.debug("In GroupWidgetOptions Constructor" , this);
			
		},
					
		postCreate:function () {
			console.debug("GroupWidgetOptions PostCreate -- " , this);
			
		},
		createOptionsGrid: function() {
			quickEdit.getDatasetColumns(this, "_getDatasetAttributes");
		},
		
		_getDatasetAttributes: function(columns) {
			this._datasetColumns = new Array();
			this._datasetColumns.push({id:"None", name:this.nls.NONE});			
			var datasetColumnsTemp = new Array();					
		
			for (var i=0;i<columns.length;i++){
				//exclude hidden columns from dataset
				if(!columns[i].isHidden()){
					datasetColumnsTemp.push({
						id: columns[i].getId(), 
						name: columns[i].getLabel(), 
						valueType: columns[i].getValueType()
					});			
				}	
				if(columns[i].getId() == "OslcResourceURI")
					this._oslcResourceURI = true;
			}			

			//sort the dataset columns
			datasetColumnsTemp.sort(function(a, b){
				if (a.name < b.name) //sort string ascending
					return -1;
				if (a.name > b.name)
					return 1;
				return 0; //default return value (no sorting)
			});			
			
			this._datasetColumns = this._datasetColumns.concat(datasetColumnsTemp);				

			console.info("Dataset Attributes...");
			console.dir(this._datasetColumns);			
			
			this.createGroupWidgetOptions();			
		},
		
		createGroupWidgetOptions: function () {	
			
			console.log ("GroupWidgetOptions.createGroupWidgetOptions... BEGIN");			
			// Create the options grid
			if(!this.optionsGrid_data)
				this.optionsGrid_data = { "identifier": "id", "idAttribute":"id", "items": [], "itemsUI": []};
			
			this.optionsGrid_data.items = new Array();
			this.optionsGrid_data.items.push({id:"LineSeparator", name:this.nls.ROWSEPARATOR, description: this.nls.ROWSEPARATOR_DESC, valueType: "checkBox"});
			this.optionsGrid_data.items.push({id:"NumberOfColumns", name:this.nls.COLUMNS, description: this.nls.COLUMNS_DESC, valueType: "numberSpinner"});
			this.optionsGrid_data.itemsUI = new Array();
			var attribName;
			for(var i=0;i<this.optionsGrid_data.items.length;i++){
				for(var j=0;j<dashletConfig.optionNameArr.length;j++){
					attribName = dashletConfig.optionNameArr[j].replace("qe_optn_","");
					if(this.optionsGrid_data.items[i].id == attribName){		
						this.optionsGrid_data.itemsUI[i] = new Object();
						this.optionsGrid_data.itemsUI[i].item_id = attribName;
						this.optionsGrid_data.itemsUI[i].item_name = this.optionsGrid_data.items[i].name;
						this.optionsGrid_data.itemsUI[i].item_desc = this.optionsGrid_data.items[i].description;						
						if(this.optionsGrid_data.items[i].valueType == 'label') {
							var tempArray = [];
							var columnsArray = this._datasetColumns;
							this.optionsGrid_data.itemsUI[i].item_value = new ComboBox({store: new Memory({ idProperty: "id", data: columnsArray})});
							if(dashletConfig.optionValueArr[j]) {
								this.optionsGrid_data.itemsUI[i].item_value.set('value', unescapeHTML(dashletConfig.optionValueArr[j]));
								for(var k=0;k<this._datasetColumns.length;k++) {
									if(dashletConfig.optionValueArr[j] == this._datasetColumns[k].id)
										this.optionsGrid_data.itemsUI[i].item_value.set('value', this._datasetColumns[k].name);
								}
							}
						} else if(this.optionsGrid_data.items[i].valueType == 'checkBox') {
							this.optionsGrid_data.itemsUI[i].item_value = new CheckBox();
							if(dashletConfig.optionValueArr[j])
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j] == "on"?true:false);
						} else if(this.optionsGrid_data.items[i].valueType == 'numberSpinner') {

							//Ramachandran - 28-Jun-13 - Task:78497: OID review for Gauges QuickEdit - Threshold textbox change to NumberSpinner
							this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner({smallDelta: 1, constraints: { places:'0,10' }});
							if(dashletConfig.optionValueArr[j]){
								this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner();
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j]);
							}else{
								this.optionsGrid_data.itemsUI[i].item_value = new NumberTextBox();
							}							
						} else {
							this.optionsGrid_data.itemsUI[i].item_value = new TextBox();
							if(dashletConfig.optionValueArr[j])
								this.optionsGrid_data.itemsUI[i].item_value.set('value', unescapeHTML(dashletConfig.optionValueArr[j]));
						}
					}
				}
				
				//if option not found in preferences, create default control
				if(!this.optionsGrid_data.itemsUI[i]){
					console.log("No settings in preferences for ..."+ this.optionsGrid_data.items[i].id);
					this.optionsGrid_data.itemsUI[i] = new Object();
					this.optionsGrid_data.itemsUI[i].item_id = this.optionsGrid_data.items[i].id;
					this.optionsGrid_data.itemsUI[i].item_name = this.optionsGrid_data.items[i].name;
					this.optionsGrid_data.itemsUI[i].item_desc = this.optionsGrid_data.items[i].description;
					if(this.optionsGrid_data.items[i].valueType == "numberSpinner") {
						this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner({smallDelta: 1, constraints: { places:'0,10' }});
					} else if(this.optionsGrid_data.items[i].valueType == "numberInput")
						this.optionsGrid_data.itemsUI[i].item_value = new TextBox();				
					  else if(this.optionsGrid_data.items[i].valueType == "label"){
						//59203: TBSM 36924: QuickEdit: inconsistent display of default value in drop down list
						//Bobby, 05Dec2012, adding None as default
						var columnsArray = [{"id":"None", "name": this.nls.NONE}];
						var tempArray = [];
						dojo.mixin(columnsArray,this._datasetColumns);
						if(this.optionsGrid_data.itemsUI[i].item_id == 'MinValue' || this.optionsGrid_data.itemsUI[i].item_id == 'MaxValue') {
							for(var j=0; j<columnsArray.length; j++) {
								var type = quickEdit.dd._mapDataType(columnsArray[j].valueType);
								if(type == "status" || type == "number") {
									tempArray.push(columnsArray[j]);
								}
							}
							columnsArray = tempArray;
						}
						this.optionsGrid_data.itemsUI[i].item_value = new ComboBox({
							value: "None", store: new Memory({ idProperty: "id", data: columnsArray})});
					}else if(this.optionsGrid_data.items[i].valueType == "combo"){
						this.optionsGrid_data.itemsUI[i].item_value = new FilteringSelect({value:"Unknown", store: new Memory({ idProperty: "id", data: this.optionsGrid_data.items[i].data })});
					}else if(this.optionsGrid_data.items[i].valueType == "checkBox")
						this.optionsGrid_data.itemsUI[i].item_value = new CheckBox();
					else
						this.optionsGrid_data.itemsUI[i].item_value = new TextBox();
					
					if(this.optionsGrid_data.items[i].def)
						this.optionsGrid_data.itemsUI[i].item_value.set('value', this.optionsGrid_data.items[i].def);
				}				
			}	

			console.log("this.optionsGrid_data -->");
			console.dir(this.optionsGrid_data);			
			console.log("this.optionsGrid_data.items.length - " + this.optionsGrid_data.itemsUI.length);	
					
			this.optionsList = new TableLayout({
				items: this.optionsGrid_data.itemsUI,
				rowTemplatePath: dojo.moduleUrl("dojoe.ssd.quickedit","templates/RowLayout.html")
			},this.groupWidgetOptionsNode);				
			if (quickEdit.enablePageLaunch == true) {
				for(var j=0;j<dashletConfig.optionNameArr.length;j++) {
					var name = dashletConfig.optionNameArr[j].replace("qe_optn_","");
					if(name == 'LaunchPage') {
						if(quickEdit.dd.launchPageSelect && dashletConfig.optionValueArr[j])							
							quickEdit.dd.launchPageSelect.set("value",dashletConfig.optionValueArr[j]);
						break;
					}
				}
			}
			this.optionsList.startup();
			console.debug ("GroupWidgetOption.createOptionsGrid... END", this.optionsList);				
		},
		
		getQuickEditOptionsString: function () {
			console.info("In getQuickEditOptionsString");
			// Check if Labels are Custom
			for(i=0;i<this.optionsGrid_data.itemsUI.length;i++) {
				if(this.optionsGrid_data.itemsUI[i].item_id == "TopLabel" || this.optionsGrid_data.itemsUI[i].item_id == "LeftLabel" || this.optionsGrid_data.itemsUI[i].item_id == "MinValue" || this.optionsGrid_data.itemsUI[i].item_id == "MaxValue") {
					var valueSet = "";
					//59203: TBSM 36924: QuickEdit: inconsistent display of default value in drop down list
					//Bobby, 05Dec2012, adding None as default
					if(this.optionsGrid_data.itemsUI[i].item_value.get('value') != this.nls.NONE){
						valueSet = this.optionsGrid_data.itemsUI[i].item_value.get('value');
					}	
					if(valueSet) {
						for(var j=0;j<this._datasetColumns.length;j++) {
							console.debug("Matching with : "+this._datasetColumns[j].id);
							if(this._datasetColumns[j].name == valueSet) {
								this.optionsGrid_data.itemsUI[i].item_value.set('value', this._datasetColumns[j].id);
								if(this.optionsGrid_data.itemsUI[i].item_id == "TopLabel")
									this._topLabelCustom = "false";
								else if(this.optionsGrid_data.itemsUI[i].item_id == "LeftLabel")
									this._leftLabelCustom = "false";
								break;
							}
						}						
					}
				}
			}
			
			var quickEditOptions="";							
			
			for(var i=0;i<this.optionsGrid_data.itemsUI.length;i++){
				var valueSet = "";				
				//59203: TBSM 36924: QuickEdit: inconsistent display of default value in drop down list
				//Bobby, 05Dec2012, adding None as default
				if(this.optionsGrid_data.itemsUI[i].item_value.get('value') != this.nls.NONE){
					valueSet = this.optionsGrid_data.itemsUI[i].item_value.get('value');
				}				
				//anurag: 03Sep2012, sending NaN creates issues
				if(valueSet == this.nls.NONE || valueSet.toString() == "NaN"){ 	
					quickEditOptions = quickEditOptions + 
										"&qe_optn_"+this.optionsGrid_data.itemsUI[i].item_id+
										"=";
				}else {
					valueSet = escape(escapeHTML(valueSet));
					console.info(this.optionsGrid_data.itemsUI[i].item_id+" : "+ valueSet );
					quickEditOptions = quickEditOptions + 
											"&qe_optn_"+this.optionsGrid_data.itemsUI[i].item_id+
											"="+valueSet;
				}
			}
			
			// Add the label flags to quickEditOptions
			quickEditOptions = quickEditOptions +
								"&qe_optn_TopLabelCustom="+this._topLabelCustom;
								
			quickEditOptions = quickEditOptions +
								"&qe_optn_LeftLabelCustom="+this._leftLabelCustom;
			
			if(quickEdit.dd.richHoverCheckBox){
				 if(quickEdit.dd.richHoverCheckBox.get('checked')){
					quickEditOptions = quickEditOptions + "&qe_optn_UIPreview=true"
				}else quickEditOptions = quickEditOptions + "&qe_optn_UIPreview="+ quickEdit.dd.richHoverCheckBox.get('checked');	 
			}
			//67644
			if(quickEdit.enablePageLaunch == true && quickEdit.dd.launchPageSelect){
				quickEditOptions = quickEditOptions + "&qe_optn_LaunchPage="+quickEdit.dd.launchPageSelect.get('value');			
			}
			return quickEditOptions;
		},
		
		setQuickEditOptionsString : function(optionsArray) {
			console.debug("In setQuickEditOptionsString");
			console.debug("optionsArray", optionsArray);
			console.debug("this.optionsGrid_data ....", this.optionsGrid_data);
			var _optionsValueArray = new Array();
			for(var j=1;j<optionsArray.length;j++) {
				var tempArray = optionsArray[j].split("=");
				_optionsValueArray.push({name : tempArray[0].slice(8), value : tempArray[1]});
			}
			console.debug("_optionsValueArray..",_optionsValueArray);
			for(i=0;i<this.optionsGrid_data.itemsUI.length;i++) {
				for(var k=0;k<_optionsValueArray.length;k++) {
					if(this.optionsGrid_data.itemsUI[i].item_id == _optionsValueArray[k].name) {
						this.optionsGrid_data.itemsUI[i].item_value.set('value', unescapeHTML(_optionsValueArray[k].value));
					}
				}
			}
			
		},
		
		destroy: function () {
			if(this.optionsGridNode){
				if(this.optionsGridNode.destroyRecursive) 
					this.optionsGridNode.destroyRecursive();
				else if (this.optionsGridNode.destroy) 
					this.optionsGridNode.destroy();
			}
			this.inherited(arguments);		
		}	
	});
});
