require({cache:{
'url:dojoe/ssd/quickedit/paramselector/templates/ParamSelector.html':"<table cellspacing=\"0\" border=\"0\" role=\"presentation\" width=\"100%\"  style='table-layout:fixed'>\r\n\t<tr>\r\n\t\t<td width=\"85%\">\r\n\t\t\t<!--ListInput  --> \r\n\t\t\t<span data-dojo-attach-point=\"listInputNode\"><div id=\"List\" data-dojo-attach-point=\"selectedList\"></div>\r\n\t\t</td>\r\n\t\t<td>\r\n\t\t\t<!--Add Selector button --> \r\n\t\t\t<div><button data-dojo-attach-point=\"add\" type=\"button\" /></div>\r\n\t\t</td>\t\t\r\n\t</tr>\r\n</table>\r\n"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
/*
 * Richa,The encoding of this file MUST be 'UTF-8 without BOM' as it contains a unicode character used for ListInput delimiter  
 */

define("dojoe/ssd/quickedit/paramselector/ParamSelector",[
    "dojo/_base/declare",
	"dojo/_base/array",
	"dojo/i18n!./nls/ParamSelector",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dojo/text!./templates/ParamSelector.html",
	"dojox/form/ListInput",
	"dijit/form/DateTextBox",
	"dijit/form/Button",
	"dojox/layout/ResizeHandle"
], function(declare,array,nlsBundle, _WidgetBase, _TemplatedMixin, template, ListInput,DateTextBox,Button,ResizeHandle) {

    return declare("dojoe.ssd.quickedit.paramselector.ParamSelector", [_WidgetBase, _TemplatedMixin], {
        templateString: template,
		//value:null,
		nls: nlsBundle,
		widgetDefinition:null,
		dlg:null,
		footer:null,
		qeCoord: null,
		paramAttributes: null,
		tableHeight: null,
		//selectedRows: null,
		columnsLength: null,
		colId: null,
		titleStats: null,
		datasetHandle: null,
        
		constructor: function(args){
		//	if(args.value) this.value = args.value;
			if(args.qeCoord) this.qeCoord = args.qeCoord;
			if(args.paramAttributes) this.paramAttributes = args.paramAttributes;
		},		
		
		postCreate: function() {
			this.inherited(arguments);
			console.info("ParamSelector.js postcreate");
			//	Richa, 36867: TBSM : First tab into TBSM Service parameter entry field in Quick Edit does not allow character entry
			this.selectedList = ListInput({name: this.paramAttributes.label, style: 'width:100%;overflow:auto;', delimiter: "÷", title: this.nls.LIST_INPUT_USAGE, inputClass: "dijit.form.TextBox", tabindex: "-1"},this.listInputNode);
			
			var addButton = new Button({
						label: this.nls.ADD_BUTTON,
						title: this.nls.ADD_BUTTON_TOOLTIP
					}, this.add);
			addButton.onClick = dojo.hitch (this, "_initDataset");
		},
		
		// summary:
		//		Hook so get('value') 
		_getValueAttr: function() {		
			var value = this.selectedList.get('value');
			return value; 
		},

		// summary:
		//		Hook so set('value', ...)		
		_setValueAttr: function(value){
			if(value){
				this.value = value;
				if(this.selectedList && this.selectedList.set) this.selectedList.set('value', value);
			}	
		},	
		
		_initDataset: function(){
			//Create the dataset

			datasetHandle = new ibm.tivoli.navmodel.Dataset({
				fetchMetaData: true,
				onError: quickEdit.errorCallback,
				onComplete: dojo.hitch(this, "_initSelector"),
				//Using the ProviderID from QE selected dataset as paramAttributes provider ID cannot be used.It would fail for remote providers. 	
				provider: quickEdit.selectedDataset.provider,
				datasource: this.paramAttributes.datasource,	
				dataset: this.paramAttributes.dataset,
				baseUrl: "/ibm/tivoli/rest",
				parameters: {eventsEnabled: false} //so that provider does not have to handle dynamic updates			
			});
		},
		
		//Adding the selector dialog box.
		_initSelector: function(){
			var div = document.createElement('div'); 
			document.body.appendChild(div);
			//45145: TBSM: Enhanced Parameter Selection: window size needs to be larger
			//var style = "width:" +this.qeCoord.w/2 + "px;height:" +this.qeCoord.h+ "px;" ;
			//Bobby: 05Mar2014, increasing width to 2/3 from 1/3
			var style = "width:" +this.qeCoord.w * 2/3 + "px;height:" +this.qeCoord.h+ "px;" ;
			
			//Creating the dialog box
			this.dlg = new dijit.Dialog({
					id: 'selectorDialog',
					"title": this.nls.ENHANCED_PARAMETER_SELECTOR + " - " + this.paramAttributes.label,
					"style": style 
				},div);
				
			this.footer = dojo.create( "div", { className: "dijitDialogPaneActionBar ", id: "footer" } );
			var self = this;
			var okButton = new dijit.form.Button( { label: this.nls.OK_BUTTON,
												id: "selectorOkbutton",
												onClick: function(){
													// Do something:
													self.applySelection();
													self.dlg.hide();
													self.destroy();
													}
												} );
			var applyButton = new dijit.form.Button( { label: this.nls.APPLY_BUTTON,
												id: "selectorApplybutton",
												onClick: function(){
													self.applySelection();
													}
												});
												
			var cancelButton = new dijit.form.Button( { label: this.nls.CANCEL_BUTTON,
												id: "selectorCancelbutton",
												onClick: function(){
													self.dlg.hide();
													self.destroy();
													}
												});

			this.footer.appendChild( okButton.domNode );   
			this.footer.appendChild( applyButton.domNode );
			this.footer.appendChild( cancelButton.domNode );			
			this.dlg.startup();
			this.dlg.show();
			
			dojo.place("<br><br><span id=\"selectorDialog_subtitle\"  data-dojo-attach-point=\"subtitleNode\">"+ this.nls.ENHANCED_PARAMETER_SELECTOR_SUBTITLE+ "</span>"  , this.dlg.titleBar , "last");
			
			//Get the height of the header and footer to create the dialog
			var footerStats = dojo.marginBox(this.footer); // The footer size doesnt seem to work
			var fBox = dojo.marginBox( this.footer );// The footer size doesnt seem to work
			this.titleStats = dojo.position(this.dlg.titleBar);
			var dialogStats =dojo.marginBox(this.dlg);

			//var tableHeight = this.qeCoord.w/2 - footerStats.h - titleStats.h;
			this.tableHeight = this.qeCoord.h  - this.titleStats.h*2 +20; //Hack.. not getting the footer height correctly.
			
			var WIDGET_DEF_INFO = {
								className: "ibm.tivoli.navmodel.TableWidgetDef",
								baseUrl: "/ibm/tivoli/rest",
								provider: "any",
								datasource: "any",
								widget: "table",
								definition: "DefaultItemsTable"
							};

			this.widgetDefinition = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.createWidgetDefinition(WIDGET_DEF_INFO.className, 
									WIDGET_DEF_INFO.definition, WIDGET_DEF_INFO, datasetHandle, null);
									
			datasetHandle.getColumns({
				onComplete: dojo.hitch(this, "setColumnDetails"),
				onError: quickEdit.errorCallback,
				properties: ["current"] 
			});	
		},
		
		setColumnDetails: function(dsColumns){
	 		var tableColumns = [];
			var defColumns = [];
			columnsLength = dsColumns.length;
			
		for(var i=0;i<columnsLength;i++){
			if(!dsColumns[i].isHidden()){
				tableColumns.push({
					id: dsColumns[i].getId(),
					field: dsColumns[i].getId(),
					name: dsColumns[i].getLabel(),
					label: {value: dsColumns[i].getLabel()},
					type: dsColumns[i].getValueType(),
					valueType: dsColumns[i].getValueType()
				});
				defColumns.push({
					id: dsColumns[i].getId(),			
					label: {value: dsColumns[i].getLabel()},			
					valueType: dsColumns[i].getValueType()
				});
			}
		}

			this.widgetDefinition.setDataSetColumns(defColumns);
			this.widgetDefinition.setTableView(tableColumns);
			
			this.widgetDefinition.getPluggableView().selectionMode = "multi";
			this.widgetDefinition.setTableCommonPaging(false);
			this.widgetDefinition.setTableColumnReordering(true);
	
			//Richa ,#41785,Disabling Properties Dialog for Enhanced Parameter Dialog
			var doNothingDefaultActionHelper = new ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper();
			dojo.safeMixin( doNothingDefaultActionHelper, {
			executeDefaultAction: function(objectContext, property) {
                // ignore since we do not want the default Properties dialog for this table
			}
});
		  	this._previewTable = new ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView({
    						dataset: datasetHandle,
                            widgetDefinition: this.widgetDefinition,
                            width: "99%",
                          //  height: "350px",
                            removeContextMenu: "true",
							height: this.tableHeight+"px",
							daHelper: doNothingDefaultActionHelper
                        });
			
			dojo.safeMixin(this._previewTable , {
					augmentGridParams: function(gridParams) {
					   this.inherited(arguments);
					//  gridParams.plugins.indirectSelection = "true";
						gridParams.enableCollapsibleToolbar = true;
						gridParams.summaryBar = false;
					   //gridParams.toolbarOptions.configTableMenu = false; // As per the OID decision support for rearranging columns is only through QuickEdit
						gridParams.toolbarOptions.refreshIcon = false;
						gridParams.toolbarOptions.actionMenu = false;
					//  gridParams.plugins.pagination = false;
					   return gridParams;
					}
				});  
		
			dojo.place( this._previewTable.domNode, this.dlg.containerNode, "last" );
			dojo.place( this.footer, this.dlg.containerNode, "last" ); 
			
			//45145: TBSM: Enhanced Parameter Selection: window size needs to be larger
			//Bobby: 05Mar2014, adding resize handle
			var handle = new ResizeHandle({
				targetContainer:this.dlg.domNode
			}).placeAt(this.dlg.domNode);
			
			dojo.connect(handle, "onResize", dojo.hitch(this,"_resize"));

			this._previewTable.setDataset(datasetHandle);

			var prevTableConn = dojo.connect(this._previewTable, "_initTableBuilder", this, function() {
				//Nothing to do here as of now.
			}); 
		},
		
		_resize: function() {
			setTimeout(dojo.hitch(this.dlg,"resize"),500);
		},
		
		applySelection: function() {
			if (this._previewTable._grid){
				// Get the column ID of our column
				var colobj = this._previewTable._grid.columns();
				var colFound = false;
				colId = null;
				dojo.some(colobj, function(col) {
					if (colFound ==  false)
					{
						var field = col.field();
						if (field == this.paramAttributes.selectorProperty){
							colId = col.id;
							colFound = true;
							//break;
							//return false;
						}
					} else
						return false
				}, this);
				
				//Get the row ID and the data to be added
				
				var rowIds = [];
				var existingValues = [];
				existingValues = this._getValueAttr();
				rowIds = this._previewTable._grid.select.row.getSelected();
				dojo.forEach(rowIds, function(rowId) {
					var cellData = this._previewTable._grid.cell(rowId,colId).data();
					var idx = array.indexOf(existingValues, cellData);
					if( idx == -1){
						//Avoid duplicates
						this.selectedList.add(cellData);
					}
				}, this);
			}
		},
		
		destroy: function() {
			console.info("Calling destroy");
			
			if(this.dlg){
				if(this.dlg.destroyRecursive) this.dlg.destroyRecursive();
				else if (this.dlg.destroy) this.dlg.destroy();
			}
			if(this._previewTable){
				if(this._previewTable.destroyRecursive) this._previewTable.destroyRecursive();
				else if (this._previewTable.destroy) this._previewTable.destroy();
			}
		}
    }); 
});