/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/tablelayout/RowLayout", [
	"dojo/_base/declare",
	"dijit/registry",	// registry.getEnclosingWidget
	"dijit/_Contained",
	"dijit/_Container",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin"
], function(declare, registry, _Contained, _Container, _WidgetBase, _TemplatedMixin){
	// module:
	//		dojoe/tablelayout/RowLayout
	// summary:
	//		A base class for row item 
	return declare("dojoe.tablelayout.RowLayout", [_WidgetBase, _Container, _Contained, _TemplatedMixin],{
		// summary:
		//		A base class for row item 
		// description:
		//		A base class for row item 

		// item: Object
		//		Displays item properties as per the template
		item: "",

		// template: String
		//		HTML template with item attributes
		templatePath : "",

		postCreate : function () {
			console.dir(this.item);
			for (x in this.item){
				//console.log("x -> "+x);
				if(this[x]){
					//console.dir(this[x]);
					//this[x].innerHTML = this.item[x];		
					if(this.item[x] instanceof Object){
						//console.info('item[x] is not text!');
						//dojo.place(cell.appendChild(document.createElement('div')), item[x]);				
						this[x].appendChild(this.item[x].domNode);
					}else{
						//this[x].appendChild(document.createTextNode(this.item[x]));		
						//this[x].innerHTML(this.item[x]);						
						var divNode=document.createElement("DIV");
						divNode.innerHTML = this.item[x];
						this[x].appendChild(divNode);
					}	
				}	
			}
		}		
	});
});
