// wrapped by build app
define("dojoe/tablex/_ColumnVisible", ["dijit","dojo","dojox","dojo/require!dijit/_WidgetBase,dijit/_TemplatedMixin,dijit/_WidgetsInTemplateMixin"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("dojoe.tablex._ColumnVisible");

dojo.require("dijit._WidgetBase");
dojo.require("dijit._TemplatedMixin");
dojo.require("dijit._WidgetsInTemplateMixin");

// define the widget class
dojo.declare (
	"dojoe.tablex._ColumnVisible", [ dijit._WidgetBase, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin ],{
	
	// summary:
	//		Private class - Configure columns - holds hide/show status for columns
	
	columnid: null,
	label: null,
	checked: false,
	//widgetsInTemplate: true,
	// Path to the template
	templateString : dojo.cache("dojoe.tablex", "templates/ColumnVisible.html", "<div>\r\n\t<input dojoType=\"dijit.form.CheckBox\" data-dojo-attach-point=\"checkbox\" name=\"${columnid}CB\" id=\"${columnid}CB\" value=\"\" role=\"checkbox\" />\r\n\t\t&#160;\r\n\t<label for=\"${columnid}CB\">${label}</label>\r\n</div>\r\n"),		
	constructor: function () {		
	},
	postCreate: function () {		
		if (this.checked) {
			this.checkbox.setChecked (this.checked);
		    //Defect 27350: Safari:In Table, Select All/ Deselect All for config columns popup does not work as expected for safari browser.
		    //Anupama -  workaround, adding a fake event
		    dijit.byId(this.checkbox.id.toString()).set("disabled", true);
		    dijit.byId(this.checkbox.id.toString()).set("disabled", false);
		}		
	},
	setVisible: function (checked) {
		this.checkbox.setChecked (checked);
		//Defect 27350: Safari:In Table, Select All/ Deselect All for config columns popup does not work as expected for safari browser.
		//Anupama -  workaround, adding a fake event
		dijit.byId(this.checkbox.id.toString()).set("disabled", true);
		dijit.byId(this.checkbox.id.toString()).set("disabled", false);
	},
	isVisible: function () {
		return this.checkbox.checked;
		
	},
	destroy: function () {		
		//memory leak issue: custom destroy method to take care of removing all widgets					
		try{
			delete this.resources_;
			//this is for destroying child templated widgets 
			//this should happen by itself but need to figure out why dijit._Templated is not taking care of it...
			var widgets = dijit.findWidgets(this.domNode);
			dojo.forEach(widgets, function(w) {
				if(w){
					if(w.destroyRecursive){
						w.destroyRecursive();
					} else if(w.destroy){
						w.destroy();
					}
				}
			});
			// this is for widgets added as child to this widget and their children..
			//not present in template
			var widgetArr = this.getChildren();
			dojo.forEach(widgetArr, function (child) {
				if(child){
					if(child.destroyRecursive){
						child.destroyRecursive();
					} else if(child.destroy){
						child.destroy();
					}
				}
			});
			this.inherited(arguments);
		}catch(ex){
			console.warn("Widget destroy failed: "+this.id+", ex="+ex.name+":"+ex.message);
		}
	}	
});
});
