/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/tablex/plugins/IndirectSelection", ["dojo", "dijit", "gridx/modules/IndirectSelect", "gridx/core/_Module"], function(dojo, dijit, IndirectSelect, _Module) {
	
    _Module.register(IndirectSelect);
    
	return  dojo.declare('dojoe.tablex.plugins.IndirectSelection', _Module, {
		
		// [Module Dependency Management] --------------------------------------------
		
		//Every module needs a name. 
		//It could be the same as another module's, which means that module's public API is the same as this one's.
		//If this name is omitted, the long class name will be used ('dojoe.tablex.plugins.IndirectSelection' in this case),
		name: 'indirectSelection',	
			
		//Required dependency modules must also exist if this module exists.
		//But they don't need to finish loading before this one.
		required: ['indirectSelect'],
		
		
		// [Module API Management] ---------------------------------------------------
		
		getAPIPath: function(){
			//This method defines how to access this module's API from the grid widget.
			//Anything returned from this function is 'deeply' mixed into grid.
			//For this example, we'll be able to call:
			//		grid.indirectSelection
			
			//If some other module needs to extend the APIs in namespace grid.testMode,
			//it can also provide this method in exact the same way, because the mixing in
			//process is performed layer by layer (deeply).
			
			//You can even directly add methods to grid: 
			//		return {
			//			newMethodForGrid: function(){...}
			// 		};
			
			return {
				indirectSelection: this
			};
		},
		
	
	
		// [Module Lifetime Management] -----------------------------------------------
		preload: function(args){
			//This is called after all modules are created, but not loaded yet. Dependancy sequence is not hornored here.
		},
	
		load: function(args, deferStartup){
			//setting selection mode set on grid to the module...
			if(this.grid.selectionMode == "single"){
				if(this.grid.indirectSelect && this.grid.select.row){
					this.grid.select.row.multiple = false;
				}
			}
		},
		
		destroy: function(){
			this.inherited(arguments);
			//do something to tear me down here.
			//e.g.: dojo.destroy(this.domNode);
		}
	
	
	});
});