require({cache:{
'url:dojoe/timeselector/templates/MessageDialog.html':"<div data-dojo-attach-point=\"containerNode\">\r\n  <div id=\"${dialogId}\" data-dojo-type=\"dijit.Dialog\" title=\"${_errorTitleText}\" data-dojo-attach-point=\"${dialogId}\" value=\"${dialogId}\" class=\"tsErrDialog\">\r\n\t <div id=\"${messageAreaId}\" class=\"tsErrDialogMsgArea\">\r\n\t     <div id=\"${msgAreaId}\" data-dojo-type=\"dijit.layout.ContentPane\" data-dojo-attach-point=\"${msgAreaId}\"></div>\r\n\t </div>\r\n\t <br><br>\r\n\t <div class=\"dijitDialogPaneActionBar tsErrDialogPaneActionBar\">\r\n\t\t<div type=\"button\" data-dojo-type=\"dijit.form.Button\" label=\"${_okText}\" data-dojo-attach-event=\"onClick: onOkClicked\"></div>\r\n\t\t</div>   \r\n\t </div>\r\n</div>"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
/******************************************************* {COPYRIGHT-TOP-RM} ***
* Licensed Materials - Property of IBM
*
* "Restricted Materials of IBM"
*
* 5724-C51
* (C) Copyright IBM Corp. 2010 All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
******************************************************* {COPYRIGHT-END-RM} ***/
/*
 * This class is responsible for displaying messages to the user.
 * It extends dojoe.timeselector.BaseDialog.
 */
define("dojoe/timeselector/MessageDialog", [
        "dojoe/timeselector/BaseDialog",
        "dijit/form/Button",
        "dojo/_base/declare",
        "dojoe/timeselector/Util",
		"dojo/i18n!dojoe/timeselector/nls/Common",
        "dojo/text!dojoe/timeselector/templates/MessageDialog.html"
        ], function(BaseDialog, Button, declare, Util, Common, template){
	return declare("dojoe.timeselector.MessageDialog", [BaseDialog],{
		 util: null, 
		   
		 templateString: template,
		   //Dynamic Ids used in template
		   dialogId: null,
		   messageAreaId: null,
		   msgAreaId: null,
		   uniqueId: null,
		   
		   /*
		    * Constructs a message dialog
		    */
		   constructor: function(diaArgs) {
			  this.util = new Util(true);
			  this._initLocalization();
			  this.uniqueId    =  diaArgs._uId;
		      this.dialogId = "_errorDialogId_"+this.uniqueId;
		      this.messageAreaId = "_messageAreaId_"+this.uniqueId;
		      this.msgAreaId = "_msgAreaId_"+this.uniqueId;
		      this.setDialogId(this.dialogId);
		   },

		   _initLocalization: function() {
			 //Localization
			  this._errorTitleText=          Common.TIME_SELECTOR_ERROR;
			  this._okText=               	 Common.Ok;
		   },
		   
		   /* 
		    * Call back when Ok is clicked. Used to hide the dialog
		    */
		   onOkClicked: function(){
		      this.hide();
		   },
		   
		   /*
		    * Displays specified message
		    */
		   showMessage: function(message,messageId){			 
				this._initMsgArea(message,messageId);
				this.show();
		   },
		   
		   _initMsgArea: function(message) {
		         this._initMsgArea(message,null);
		     },

		   /*
		    * Sets content attribute of message area
		    */
		   _initMsgArea: function(message,messageId) {
		      	this.setWidgetValue(this.msgAreaId,"content",(messageId?messageId+":<br/>":"")+message);		   
		   }
	});
});


