// wrapped by build app
define("ibm/tivoli/tip/dijit/TIPContextMenu", ["dijit","dojo","dojox","dojo/require!dijit/Menu,ibm/tivoli/tip/dijit/TIPMessageDialog,dijit/_Widget,dijit/_Templated,ibm/tivoli/tip/dojo/Global,ibm/tivoli/tip/dojo/Server,ibm/tivoli/tip/dijit/ContextMenuAdapter,ibm/tivoli/tip/dojo/EventUtil,ibm/tivoli/tip/dijit/TIPContextMenuProvider,ibm/tivoli/tip/dijit/CMSMenuProvider,ibm/tivoli/tip/dijit/CMSMenuProviderV2"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dijit.Menu");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("ibm.tivoli.tip.dojo.Global");
dojo.require("ibm.tivoli.tip.dojo.Server");
dojo.require("ibm.tivoli.tip.dijit.ContextMenuAdapter");
dojo.require("ibm.tivoli.tip.dojo.EventUtil");
dojo.require("ibm.tivoli.tip.dijit.TIPContextMenuProvider");
dojo.require("ibm.tivoli.tip.dijit.CMSMenuProvider");
dojo.require("ibm.tivoli.tip.dijit.CMSMenuProviderV2");


dojo.provide("ibm.tivoli.tip.dijit.TIPContextMenu");



/**
 *  Provides dynamic context menu support.
 *  How do you use this?
 *  First, you create an instance of this context menu similar to:
 *     this._contextMenuAdapter = new ibm.tivoli.tip.dijit.TIPContextMenu({cmProvider: this.cmProvider});
 *  Note: you pass in an instance of a context menu provider (see objects lower in this file)
 *
 *  Second, you latch whatever event you want to create the context menu.  For 
 *  Grids, you might do something like this:
 *     this._onRowContextMenuListener = dojo.connect( this.grid, "onRowContextMenu", this, "_onRowContextMenu" );
 *  Don't forget to disconnect this listener when your object is destroyed.
 *
 *  Third, you create the method that gets called by the above connect, and call
 *  the contextMenuOpen on this context menu with whatever context you want 
 *  processed.  Again, in a Grid example:
 *   _onRowContextMenu: function( e )
 *   { 
 *     var row = e.grid.model.getRow( e.rowIndex );
 *     
 *     if ( row )
 *     {
 *       //select the row that the context menu was initiated on
 *       e.grid.selection.unselectAll( e.rowIndex );
 *       e.grid.selection.setSelected( e.rowIndex, true );
 *               
 *       //tell the context menu adapter to show the menu
 *       // no context is provided because we overload the _loadMenuItems method
 *       this._contextMenuAdapter.contextMenuOpen( e, {selectedData: this.getSelectionData()} );
 *     }
 *   },
 *
 *  
 */
dojo.declare("ibm.tivoli.tip.dijit.TIPContextMenu",
              ibm.tivoli.tip.dijit.ContextMenuAdapter,
{
   cmProvider: null,       // TIPContextMenuProvider
   cmClientProvider: null,
   url: "no_url_needed",   // Note we have to pass something to ContextMenuAdapter
                           // for the url so that we can override _loadMenuItems
   
   /****************************************************************************
   * Callback that should be overloaded to be told when a menu item is clicked
   * and an action should occur
   ****************************************************************************/
   onMenuItemClick: function( menuItem )
   { 
      console.debug("-------------- menuItem :",menuItem);
      try{
    	  this.cmClientProvider.getMenuCommand(menuItem.actionID, this._context, menuItem);
      }catch(e){
    	  this.cmProvider.getMenuCommand(menuItem.actionID, this._context, menuItem);
      }
   },

   /****************************************************************************
   * Synchronously Call a JSON Url to get the menu items
   *
   ****************************************************************************/
   _loadMenuItems: function()
   {
	   return this.cmClientProvider ? this.cmClientProvider.getMenuItems( this._context ).concat (this.cmProvider.getMenuItems( this._context )) : this.cmProvider.getMenuItems( this._context );
   }

});


});
