// wrapped by build app
define("ibm/tivoli/tip/navwidget/table/dijit/ItemsTableView", ["dijit","dojo","dojox","dojo/i18n!ibm/tivoli/tip/navwidget/nls/resources","dojo/require!dojo/data/ItemFileReadStore,ibm/tivoli/navmodel/DatasetItemsStore,ibm/tivoli/tip/navwidget/table/dijit/AbstractTableView,ibm/tivoli/tip/navwidget/table/dijit/NavModelTable"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * �Restricted Materials of IBM�
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide ("ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView");

dojo.require("dojo.data.ItemFileReadStore");   // 49426  Gridx 
dojo.require("ibm.tivoli.navmodel.DatasetItemsStore");

dojo.require ("ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView");
dojo.require("ibm.tivoli.tip.navwidget.table.dijit.NavModelTable");

dojo.requireLocalization("ibm.tivoli.tip.navwidget", "resources");

ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView");

dojo.declare ("ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView",
	ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView,
	{
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	//***************************
	// "Private"
	//***************************
	
	// _trace: [private] Trace
	//		Utility for trace and logging
	_trace: ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView._trace,
	
	constructor: function () {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		//this._global = ibm.tivoli.tip.dojo.Global.setSingleton( "123", " ");
		this.title = this.commonResources.RESOURCE_VIEW;
		
		// 58766
		this.label = this.commonResources.RESOURCE_VIEW;
		
		this.labelIconClass = "resourceViewIcon";
	    this._pDEFAULT_WIDGET_DEF_INFO = {
			className: "ibm.tivoli.navmodel.TableWidgetDef",
			baseUrl: "/ibm/tivoli/rest",
	    	provider: "any",
	    	datasource: "any",
	    	widget: "table",
	    	definition: "DefaultItemsTable"
		},
		
		this._pTableType = "item";
		this._pTableClassName = "ibm.tivoli.tip.navwidget.table.dijit.NavModelTable";

	},
	
	postCreate: function() {
		// 58766
		dojo.attr(this.domNode, 'aria-label', this.label);
		this.inherited(arguments);
	},
	
	// overrides AbstractTableView  49426
	augmentGridParams: function(gridParams) {    
		// summary:
		//		Set up gridParams as needed
		// description:
		//		Modify the gridParams to compensate for what dojoe.tablex wants
		
		// 58766
		if(!gridParams.label) {
			gridParams.label = this.label;
		}
		
        if (gridParams.filter) {
        	if (!gridParams.filter.isServerSide) {
        		gridParams.filter.isServerSide = true;
        	}
        }
        else {
        	gridParams.filter = {isServerSide : true}
        }
		
		// Reset the structure value to only the array of column descriptors and not the defaultCell info
		// Gridx does not support multiple or complicated nested layouts
 		if ((gridParams.structure.length == 1) && (gridParams.store instanceof dojo.data.ItemFileReadStore)) {						
			gridParams.structure = [{}];
		} else if ((gridParams.structure.length == 1) && ("rows" in gridParams.structure[0]) && (gridParams.structure[0].rows instanceof Array)) {
			gridParams.structure = gridParams.structure[0].rows; 
		} else if((gridParams.structure.length == 2) && ("rows" in gridParams.structure[0]) && (gridParams.structure[0].rows instanceof Array) && ("rows" in gridParams.structure[1]) && (gridParams.structure[1].rows instanceof Array)  ) {
	    	// if there are some defined locked columns, merge them into one array since
	    	// Gridx does not support true column locking, they will however appear
	    	// at the beginning of the table
	    	var layout1 = gridParams.structure[0].rows;
	    	var layout2 = gridParams.structure[1].rows;
	    	var layoutMerged = [];
    	
	    	layoutMerged = layout1.concat(layout2);

	    	gridParams.structure = layoutMerged;  	
	    }
		
		return gridParams;
	},	
	
	_createTableStore: function(columnIds){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// columnIds:
		//		
		
		// create or update store
		if (!this._dataStore) {   // 49426  Gridx (split out to always return some store)
            if (this.dataset) {
            	this._dataStore = new ibm.tivoli.navmodel.DatasetItemsStore({dataset:this.dataset, defaultProperties:columnIds, returnItem:true});
            }
            else {
				//No dataset, so just create an empty store
				/*var emptyStore = new dojo.data.ItemFileReadStore({
										data: { items: []}
	                				});
				this._dataStore = emptyStore;*/
				console.warn("ItemsTableView.js: No dataset, skipping empty datastore");
            }
		   this.inherited(arguments);
		}
	}	
	
});

});
