// wrapped by build app
define("ibm/tivoli/tip/navwidget/topology/dijit/DiagrammerCanvas", ["dijit","dojo","dojox","dojo/require!dijit/layout/ContentPane,dojox/collections/Dictionary,ibm/tivoli/tip/navwidget/dijit/NavWidgetPluggableView,ibm/tivoli/tip/navwidget/dojo/NavWidgetPluggableViewSelection,ibm/tivoli/tip/navwidget/dojo/NavWidgetPluggableViewObjectContext,ibm/tivoli/navmodel/DatasetItemsStore,ibm/tivoli/navmodel/DatasetLinksStore,ibm/tivoli/tip/navwidget/dojo/Timer,ibm/tivoli/tip/navwidget/dijit/CustomContentTooltip,ibm/tivoli/tip/navwidget/dijit/AsynchContextMenu,ibm/tivoli/tip/navwidget/dijit/RESTContextMenuProvider,ibm/tivoli/tip/navwidget/properties/dijit/PropertiesNotebookGeneralTab,ibm/tivoli/tip/navwidget/topology/dijit/DefaultActionHelper,ibm/tivoli/tip/navwidget/topology/dijit/MenuProviderHelper,ibm/tivoli/navmodel/Trace,dojo/data/ItemFileReadStore"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2014.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * "Restricted Materials of IBM"
 * 
 * Copyright IBM Corp. 2011, 2012, 2013, 2014 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas");

dojo.require("dijit.layout.ContentPane");
dojo.require("dojox.collections.Dictionary");   
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext");
dojo.require("ibm.tivoli.navmodel.DatasetItemsStore");
dojo.require("ibm.tivoli.navmodel.DatasetLinksStore");
dojo.require("ibm.tivoli.tip.navwidget.dojo.Timer");
dojo.require("ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip");
dojo.require("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu");
dojo.require("ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider");
dojo.require("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookGeneralTab");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper");
dojo.require("ibm.tivoli.navmodel.Trace");
//AWE TODO: Temporarily using dojo["require"] to get around custom build issues until we officially move to Dojo Diagrammer
dojo["require"]("ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas");
dojo["require"]("ibm_ilog.diagram.widget.Diagram");    
dojo["require"]("ibm_ilog.diagram.graphlayout.ServerSideLayout");    
dojo["require"]("ibm_ilog.diagram.templating");    
dojo["require"]('ibm_ilog.graphlayout.shortlink.ShortLinkLayout');    
dojo["require"]('ibm_ilog.diagram.gfxlayout.GridLayout');    
dojo["require"]('ibm_ilog.diagram.adorners.LinkAdorner');

dojo.require("dojo.data.ItemFileReadStore");

ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas",
	[dijit.layout.ContentPane, ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas],
	 {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		showLablesOnLinks: true,
		
		// contextMenu: [public] Object
		//		The context menu for this view
		contextMenu: null,		
		
		// cmProvider: [public] Object
		//		The context menu provider for this view.
		//      It is usually passed in on the constructor in the canvasCreationArgs and mixed in
		cmProvider: null,
		
		// daHelper: [public] Object
		//		The default action helper for this view.
		//      It is usually passed in on the constructor in the canvasCreationArgs and mixed in		
		daHelper: null,
		
		// showTooltip: boolean
		//		Optionally include or don't include tooltip
		//      Default is to include it, but the flag can be passed in on creation args to change it
		showTooltip: true,   	
		
		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
		_trace: ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas._trace,		
		
		// _tooltip: [private] Object
		//		Actual tooltip instance
		_tooltip: null,
		
		// _rolloverTarget: [private] Object
		//		The graph item/link/relationship under the mouse cursor
		_rolloverTarget: null,
		
		// _tooltipProperties: [private] Object
		//		The properties panel inserted into the tooltip
		_tooltipProperties: null,
		
		// _propOnSetDatasetConnection: [private] Object
		//		Callback handle for when the tooltip properties panel has the data from the dataset
		_propOnSetDatasetConnection: null,
		
		// _propOnSetObjectsConnection: [private] Object
		//		Coming soon
		_propOnSetObjectsConnection: null,		
		
		// _menuCloseHandle: [private] Object
		//		Dojo callback event handle
		_menuCloseHandle: null,
		
		// _openingNewMenu: [private] Boolean
		//		Indicates if the context menu is in the process of opening
		_openingNewMenu: false,		
		
		// _cxtMenuEvt: [private] Object
		//		Event copy cache (to work around an IE bug)
		_cxtMenuEvt: null,
		
		// _loadingMenuId: [private] String
		//		Resource string ID for the menu loading message
		_loadingMenuID: "LOADING_ID",		
	  
		// _layoutAlgorithm: [private] Object
		//		Last layout algorithm
		_layoutAlgorithm: null,
		
		// _layoutParams: [private] Object
		//		Last set of layout parms
		_layoutParams: null,	  

		// _availableLayoutAlgorithms: [private] Array[]
		//       All available layout algorithms supported
		_availableLayoutAlgorithms: ["tree", "hierarchical", "grid", "forceDirected", "shortLink", "longLink"],
		
		// _availableLayoutParams: [private] Array[][][]
		//       All available layout params and possible values
		//       (each nested array matches up positionally to the array of _availableLayoutAlgorithms
		_availableLayoutParams: [
		                          [ 
		                            ["layoutMode", "free|level|tip over|tip leaves over|tip roots over|tip roots and leaves over|radial|alternating radial"],
		                            ["flowDirection", "right|left|top|bottom"],
		                            ["globalLinkStyle", "straight|no reshape|orthogonal|mixed"],
		                            ["connectorStyle", "automatic|centered|evenly spaced"],
		                            ["globalAlignment", "center|border center|east|west|tip over|tip over west|tip over east west|tip over both sides|mixed"],
		                            ["levelAlignment", "center|north|south"],
		                            ["aspectRatio", "1|10"]
		                          ],
		                          [
		                            ["flowDirection", "right|left|top|bottom"],
		                            ["levelJustification", "center|left|right|top|bottom"],
		                            ["levelingStrategy", "optimal|semi optimal|higher levels|lower levels|spread out"],
		                            ["globalLinkStyle", "polyline|orthogonal|straight|mixed|no reshape"],
		                            ["connectorStyle", "automatic|centered|evenly spaced"],
		                            ["horizontalNodeOffset", "40|200"],
		                            ["horizontalLinkOffset", "15|200"],
		                            ["horizontalNodeLinkOffset", "20|200"],
		                            ["verticalNodeOffset", "40|200"],
		                            ["verticalLinkOffset", "15|200"],
		                            ["verticalNodeLinkOffset", "20|200"]
		                          ],
		                          [
		                            ["layoutMode", "tile to grid fixed height|tile to grid fixed width|tile to columns|tile to rows"],
		                            ["globalHorizontalAlignment", "center|left|right"],
		                            ["globalVerticalAlignment", "center|top|bottom"],
		                            ["maxNumberOfNodesPerRowOrColumn", "1|10"]
		                          ],
		                          [
		                            ["layoutMode", "fast multilevel|incremental|non incremental"],
		                            ["preferredLinksLength", "25|45"],
		                            ["linkStyle", "straight|no reshape"],
		                            ["maxAllowedMovePerIteration", "5|25"],
		                            ["allowedNumberOfIterations", "250|1250"],
		                            ["convergenceThreshold", "0.1|3.5"]
		                          ],
		                          [
		                            ["globalLinkStyle", "direct|orthogonal|mixed|no reshape"],
		                            ["globalSelfLinkStyle", "two bends orthogonal|three bends orthogonal"],
		                            ["globalConnectorStyle", "automatic|fixed offset|evenly spaced|mixed"],
		                            ["flowDirection", "right|left|top|bottom"],
		                            ["levelJustification", "center|left|right|top|bottom"],
		                            ["levelingStrategy", "optimal|semi optimal|higher levels|lower levels|spread out"],
		                            ["connectorStyle", "automatic|centered|evenly spaced"],
		                            ["linkOffset", "0|20"],
		                            ["minFinalSegmentLength", "10|100"]
		                          ],
		                          [
		                            ["globalLinkStyle", "direct|orthogonal|mixed|no reshape"],
		                            ["flowDirection", "right|left|top|bottom"],
		                            ["levelJustification", "center|left|right|top|bottom"],
		                            ["levelingStrategy", "optimal|semi optimal|higher levels|lower levels|spread out"],
		                            ["connectorStyle", "automatic|centered|evenly spaced"],
		                            ["verticalMinOffset", "1|20"],
		                            ["horizontalMinOffset", "1|20"]
		                          ]
		                        ],
	
		_ilogDiagrammer: null,
		
		_itemStore: null,
		
		_linkStore: null,
       
		_nodeImageCache: new dojox.collections.Dictionary(),
		
		_nodeStatusFillCache: new dojox.collections.Dictionary(),

		_nodeTemplate: null,

		_linkTemplate: null,
		
		_connectionHandles: [],
		
		_canvasBackgroundOnContextMenuHandle: null,
		
		// _EMPTY_DATASET_STRING: [private const] String
		_EMPTY_DATASET_STRING: "",
		
		_emptyDatasetLabel: null,
		
		_NO_STATUS_KEY: "no_status",

        // _DEFAULT_WIDGET_DEF_INFO: [const] String[]
		//		Coming soon
		//_DEFAULT_WIDGET_DEF_INFO: {
		//	className: "ibm.tivoli.navmodel.TopoWidgetDef",
		//	baseUrl: "/ibm/tivoli/rest",
	    //	provider: "any",
	    //	datasource: "any",
	    //	widget: "topology",
	    //	definition: "DefaultTopology"
		//},
      
        constructor: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			//AWE TODO
        	 
            //Signal to superclass we'll be firing onSetDataSetLoadComplete manually
			this._setDatasetLoadDataCompletesSynchronously = false;
			
			//We don't have a widget def specific to this view, so let's signal to 
	        //super class not to try and load any widget defs on our behalf
			this._usesWidgetDefinition = false;
			
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Node, "textColor", "#000000");
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Node, "status", "Unknown");
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Node, "statusColor", "#FF0000");
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Node, "statusFill", "#F8F8F8");
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Node, "statusImage", "./zoom_in.gif");
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Node, "largeImage", "./zoom_in.gif");
            ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Node, "selectedStrokeColor", "#0000FF");
            ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Node, "disabled", false);
            
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Link, "arrowColor", "#000000");
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Link, "linkLabel", "label");
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Link, "selectedStrokeColor", "0000FF");
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Link, "selectedArrowColor", "0000FF");
			ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.Link, "disabled", false);
			
			//AWE TODO: dojo.experimental doesn't seem to write out anything, so doing it manually
			//dojo.experimental("ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas", "Prototyping use of ILOG Dojo Diagrammer");
			//Removing this warning as development is proceeding
			//var message = "EXPERIMENTAL: ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas -- APIs subject to change without notice. Prototyping use of ILOG Dojo Diagrammer";
			//console.warn(message);
        },
        
        destroy: function() {
        	// remove all listeners
        	dojo.forEach(this._connectionHandles, function(h) {dojo.disconnect(h);});
        	this._connectionHandles = [];
        	
        	// Get rid of the tooltip if there is one
    		if (this._tooltip) {
    			this._tooltip.removeTarget(this._ilogDiagrammer.id);
    			this._tooltip.destroyRecursive();
    		}
        	
        	// Clean up the ILOG Diagrammer and local data
        	// Do not destroy the dataset as that is done by the parent TopologyView
        	if (this._ilogDiagrammer && !(this._ilogDiagrammer._destroyed)) {
        		// disconnect handle for background context menu callback
        		this._ilogDiagrammer.getViewport().getEventSourceBackground().disconnect(this._canvasBackgroundOnContextMenuHandle);
        		// If we have an ILOG Diagrammer and it is not already destroyed as a child widget
        		this._ilogDiagrammer.destroy();
        	}
        	this._ilogDiagrammer = null;
        	this._availableLayoutAlgorithms = null;
        	this._availableLayoutParams = null;
        	this._nodeImageCache = null;
        	if (this._itemStore) {
        		// dojo.forEach(this._itemStoreConnects, dojo.disconnect);
        		// this._itemStoreConnects = [];
        		this._itemStore.close();
        		this._itemStore = null;
        	}
        	if (this._linkStore) {
        		// dojo.forEach(this._linkStoreConnects, dojo.disconnect);
        		// this._linkStoreConnects = [];
        		this._linkStore.close();
        		this._linkStore = null;       		
        	}
        	
        	this.inherited(arguments);
        },
        
        postCreate: function() {
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	
        	this._initNodeStatusFillCache();
            this._myNodeTemplate = this._myNodeTemplate.replace("gradient2.PNG", this._cleanUpImagePath("[widget]\/images\/gradient2.PNG"));
            this._nodeTemplate = ibm_ilog.diagram.declareTemplate(this._myNodeTemplate);
            this._linkTemplate = ibm_ilog.diagram.declareTemplate(this._myLinkTemplate);
            
	        // Check if a context menu provider was passed in
	        if (!this.cmProvider) {
		        // create a default context menu provider
	            var helper = new ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper();
		        this.cmProvider = new ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider(
		        			{
		        				view: this,
		        				getMenuItemsCallback: dojo.hitch(helper, helper.getMenuItems),
		        				getMenuCommandCallback: dojo.hitch(helper, helper.getMenuCommand)
		        			}
		        		);	        	
	        }

	        // create the context menu using the provider
	        this.contextMenu = new ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu({cmProvider: this.cmProvider});            

            this.inherited(arguments);
        },        

		//_getDefaultWidgetDefInfo: function(){
		//	return this._DEFAULT_WIDGET_DEF_INFO;
		//},
		
        _onLoadedTimer: null, //AWE TODO
        _makeNavWidgetTimer: null,
		_setDatasetLoadData: function(dataset){		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	// dataset:
        	//		
			
        	this._makeNavWidgetTimer = new ibm.tivoli.tip.navwidget.dojo.Timer();
        	this._makeNavWidgetTimer.start();
        	
        	this.showBusyPane();
			
        	if (!this._ilogDiagrammer) {                
                /* AWE TODO
                 * <div dojoType="ibm_ilog.diagram.widget.Diagram" id="graph" style="width: 900px; height: 400px;"
                automaticNodeLayout= "true" automaticLinkLayout= "true" 
                startNodeBinding="identity1" endNodeBinding="identity2"
                createLinksForHierarchy= "false">
                <!-- 
                 onNodeCreated="onNodeCreated" onLinkCreated="onLinkCreated"
                nodeTemplateFunction="getNodeTemplate" linkTemplateFunction="getLinkTemplate"
                 -->
             </div>
                 */
        		
        		// The default link focus adorner template sets the color of focussed links to magenta,
        		// so we need to set it to match the selectedStrokeColor for selected links
        		var template = (ibm_ilog.diagram.templates.defaultAdornerTemplates).item("LinkFocusAdorner");
        		template[0].children[0].stroke.color = [0,0,255];
        		// The link adorner also does not properly handle double-click events to echo back to the link
        		// objects (when the link is focused, primarily), so need to extend it to make onLinkDblClick
        		// work reliably
        		var oldEchoConnect = ibm_ilog.diagram.adorners.LinkAdorner.prototype._echoConnect;
        		ibm_ilog.diagram.adorners.LinkAdorner.extend({
        		    _echoConnect: function() {
        		        // Extend the _echoConnect so we can add catch link double click events 
        		        oldEchoConnect.apply(this);
        		        if (this['_path']) {
        		            this._buildEchoConnection('ondblclick');
        		        }
        		    }
        		});
        		
        		// 48410: Dojo Topology view pan action is different than in the Flex Topology view
           		// The default PanInteractor has the pan action defined as Shift+MB1, but to make this
        		// work the same as for the Flex topology view default, we do not want shift, just drag
        		// on the canvas background to initiate the pan action
        		var oldBuildInputFilter = ibm_ilog.diagram.interactors.PanInteractor.prototype._buildInputFilter;
        		ibm_ilog.diagram.interactors.PanInteractor.extend({
        		    _buildInputFilter: function(spec) {
        		        // Extend the _buildInputFilter so we can turn off the Shift key from the spec 
        		    	if ("shift" in spec) {
        		    		spec.shift = false;
        		    	}
        		    	// now call the original implementation with the modified spec
        		        return oldBuildInputFilter.call(this, spec);
        		    }
        		});        		
        		
        		var diagrammerId = this.id + "_Diagram"; 
        			
        		// Now set up configuration properties of the Diagram
                var widgetProperties = {
                	id: diagrammerId,
                	marquee: (this.widgetDefinition.getSelectionMode() != "single"),
                    nodesQuery: {},
                    linksQuery: {},
                    createLinksForHierarchy: true,
                    automaticNodeLayout: true,
                    automaticLinkLayout: true,
                    startNodeBinding: "identity1",
                    endNodeBinding: "identity2",
                    onNodeCreated: dojo.hitch(this, this._onNodeCreated),
                    onLinkCreated: dojo.hitch(this, this._onLinkCreated),
                    nodeTemplate: this._nodeTemplate,
                    linkTemplate: this._linkTemplate
                    // nodeTemplateFunction: dojo.hitch(this, this._getNodeTemplate),
                    // linkTemplateFunction: dojo.hitch(this, this._getLinkTemplate)
                };
                
    			this._ilogDiagrammer = new ibm_ilog.diagram.widget.Diagram(widgetProperties);    
    			
   			 	this.attr("content", this._ilogDiagrammer);
   			 	
                this.selection.setMode(this.widgetDefinition.getSelectionMode());
   			 	// If single selection, tell the Dojo Diagrammer to disable extended selection
   			 	if (this.selection.getMode() == "single") {
   			 		this._ilogDiagrammer.getSelection().setMultiSelectionEnabled(false);
   			 	}
   			 	
   			 	this._emptyDatasetLabel = this._ilogDiagrammer.getSurface().createText({x:10,y:20,text:"",align:"start"}).setFont({family:"Arial",size:"10pt"}).setFill("black");
   			 	
   		        // Optionally create the tooltip
   		        if (this.showTooltip) {
   		        	// create tooltip
   		        	this._tooltip = new ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip({connectId: [ diagrammerId ],
   		                                                                                 getCustomContentCallback: dojo.hitch(this, this._customTooltip)
   												//position : ["after", "below"]

   											});
   		        
   		        	// Override the tooltip behavior specifically for topology
   		        	dojo.safeMixin(this._tooltip, {
   		        	
   		        		// Override open to set tooltip position over the _ilogDiagrammer near the node or link
   		        		open: function(target) {
   		        			// Create a rectangle for positioning the tooltip, otherwise default
   		        			// position is outside the DOM node of the _ilogDiagrammer
   		        			var aroundRect = target.rolloverTargetRect;
   		        			
   		        			// make sure the rolloverTargetRect has been set to actually display the tooltip
   		        			// (it may not be if we got a rollover while the context menu is displayed)
   		        			if (aroundRect != null) {
   		        				// replace the target node, the _ilogDiagrammer, with this rectangle
   		        				arguments[0] = aroundRect;
   		        				this.inherited(arguments);
   		        			}
   		        		},
   		        		_onTargetMouseEnter: function(e) {
   		        			// ignore since _ilogDiagrammer is not the real target (we handle the tooltip)
   		        		},
   		        		_onTargetMouseLeave: function(e) {
   		        			// ignore since _ilogDiagrammer is not the real target (we handle the tooltip)
   		        		},
   		        		_onTargetBlur: function(e) {
   		        			// ignore since_ilogDiagrammer is not the real target (we handle the tooltip)
   		        		},
   		        		_onTargetFocus: function(e) {
   		        			// ignore since _ilogDiagrammer is not the real target (we handle the tooltip)
   		        		},
   		        		// added helper method to trigger the timer to display the tooltip
   		        		hover: function(target) {
   		        			this._onHover(target);
   		        		},
   		        		// added helper method to dismiss the tooltip
   		        		unHover: function(target) {
   		        			this._onUnHover(target);
   		        		}
   		        	});
   		        	this._tooltip.startup();
   		        }
        	}
        	
        	//Populate the diagrammer based on the dataset
        	var useFileReadStore = false;
            if (useFileReadStore) {
            	var nodeCount = 200;
            	var linkPerNodeCount = 4;
            	var nodeData = this._buildSampleNodesJson(nodeCount);
            	var linkData = this._buildSampleLinksJson(nodeCount, linkPerNodeCount);
            	this._itemStore = new dojo.data.ItemFileReadStore({
                    //url: "./nodesLarge.json"
            		data: nodeData
                });
                this._linkStore = new dojo.data.ItemFileReadStore({
                    //url: "./linksLarge.json"
                	data: linkData
                });
            } else {
            	this._itemStore = new ibm.tivoli.navmodel.DatasetItemsStore({
                    dataset: dataset 
            	});
                this._linkStore = new ibm.tivoli.navmodel.DatasetLinksStore({
                	dataset: dataset
                });
            }

            var onLoadedCallback = function() {
            	// Now, we can finally send notification we're done loading the dataset. We use setTimeout to get on
        		// different thread so it doesn't interfere with any work Dojo Diagrammer might still be doing to update display.
        		if (this.isSetDatasetLoadDataActive()) {
        		   setTimeout(dojo.hitch(this, this._onSetDatasetLoadComplete, this.dataset), 0);
        		}
        		
        		// Set the empty dataset label in the surface accordingly
        		if (this.dataset.getItemCount() == 0 && this.dataset.getLinkCount() == 0) {
        			this._emptyDatasetLabel.setShape({text: this._EMPTY_DATASET_STRING});
        		}
        		else {
        			this._emptyDatasetLabel.setShape({text: ""});
        		}
            	if (this._onLoadedTimer) {
					// console.debug("ON LOADED!!!!!! time:; " + this._onLoadedTimer.stopAndGetTraceString());
				}
            };
            
            if (dataset) {
            	dojo.connect(this._ilogDiagrammer, "onLoaded", dojo.hitch(this, onLoadedCallback));
            	
            	this._ilogDiagrammer.set("nodesStore", this._itemStore);
            	this._ilogDiagrammer.set("nodesQuery", {});
            	this._ilogDiagrammer.set("linksStore", this._linkStore);
            	this._ilogDiagrammer.set("linksQuery", {});
            	
    			// Handle settings determined by current widget def
    			this.setLayoutToCanvasBasedOnWidgetDef();
    			
    			// Handle settings determined by current dataset / subgraph
    			this._setLayoutToCanvasBasedOnDataset();
            	
            	this._onLoadedTimer = new ibm.tivoli.tip.navwidget.dojo.Timer();
            	this._onLoadedTimer.start();
            	this._ilogDiagrammer.load();
            	// this._doTree();
            	this.performLayout(true);
            	
            	// set up listeners for interaction events within the graph area
            	this._connectionHandles.push(dojo.connect(this._ilogDiagrammer.getSelection(),"onSelectionChanged", dojo.hitch(this, this._selectionChangedCallback)));
            	this._connectionHandles.push(dojo.connect(this._ilogDiagrammer,"onNodeDblClick", dojo.hitch(this, this._doubleClickCallback)));
            	this._connectionHandles.push(dojo.connect(this._ilogDiagrammer,"onLinkDblClick", dojo.hitch(this, this._doubleClickCallback)));
            	this._connectionHandles.push(dojo.connect(this._ilogDiagrammer,"onNodeContextMenu", dojo.hitch(this, this._nodeContextCallback)));
            	this._connectionHandles.push(dojo.connect(this._ilogDiagrammer,"onLinkContextMenu", dojo.hitch(this, this._linkContextCallback)));
            	this._canvasBackgroundOnContextMenuHandle = this._ilogDiagrammer.getViewport().getEventSourceBackground().connect("oncontextmenu", dojo.hitch(this, this._backgroundContextCallback));
            	this._connectionHandles.push(dojo.connect(this._ilogDiagrammer,"onNodeMouseOver", dojo.hitch(this, this._nodeMouseOverCallback)));
            	this._connectionHandles.push(dojo.connect(this._ilogDiagrammer,"onNodeMouseOut", dojo.hitch(this, this._nodeMouseOutCallback)));
            	this._connectionHandles.push(dojo.connect(this._ilogDiagrammer,"onLinkMouseEnter", dojo.hitch(this, this._linkMouseEnterCallback)));
            	this._connectionHandles.push(dojo.connect(this._ilogDiagrammer,"onLinkMouseLeave", dojo.hitch(this, this._linkMouseLeaveCallback)));
            	
            	// 48410: Dojo Topology view pan action is different than in the Flex Topology view
            	// set the pan action interactor to not initiate a drag pan if the mouse is over a node or link,
            	// only if on the canvas background
            	this._ilogDiagrammer.getInteractor("pan").setOnShapes(false);
           }
            else {
        		//No dataset, so fire _onSetDatasetLoadComplete
        		setTimeout(dojo.hitch(this, this._onSetDatasetLoadComplete, dataset), 0);
        	}
			 
        	//Call superclass
        	this.inherited(arguments);
        },
        
        //***************************
        //***************************
		// "Public" -- functions from BaseCanvas
		//***************************
        //***************************
		print: function(/*int*/ pageCount, /*Object*/ pageMargin, /*Object*/ printAsBitmap){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// pageCount:
			//		Coming soon
			// pageMargin:
			//		Coming soon
			// printAsBitmap:
			//		Coming soon
			
        	this.inherited(arguments);
		},

		zoomIn: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
        	 var viewport = this._ilogDiagrammer.getViewport();
        	 viewport.setZoom(viewport.getZoom() * 2);
		},
		
		zoomOut: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			var viewport = this._ilogDiagrammer.getViewport();
			viewport.setZoom(viewport.getZoom() / 2);
		},		

		setZoomLevel: function(/*float*/ zoomLevel){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			this._ilogDiagrammer.getViewport().setZoom(zoomLevel);
		},

		setMouseMode: function(/*Object*/ mouseMode){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// mouseMode: 
			//		Coming soon
			
	        console.log(">> TODO: Not yet implemented for Dojo canvas.");			
			// this.inherited(arguments);
		},
		
		fitContents: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			try {
        		this._ilogDiagrammer.getGraph().fitToContents(10, false);    
        	} catch (ex) {
        		//There was a problem - ignore that
            }
		},
		
		exportAsImage: function(/*Object*/dialogTitle, /*Object*/questionText, /*Object*/pngOptionLabel, /*Object*/jpgOptionLabel, /*Object*/exportButtonLabel, /*Object*/cancelButtonLabel, /*Object*/baseDefaultFileName){	
			// summary:
			//		Causes diagram contents to be exported as an image. 
			// description:
			//		Causes diagram contents to be exported as an image. 
			// tags:
			//		public
			
			this.inherited(arguments);
		},

		setBackgroundColor: function(/*Object*/ backgroundColor) {
			this.inherited(arguments);
		},

		getAvailableLayoutAlgorithms: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			return this._availableLayoutAlgorithms;
		},

		getAvailableLayoutParams: function(/*Object*/ alg){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// alg:
			//		Coming soon
			
			var index = -1;
			if (alg) {
				index = dojo.indexOf(this._availableLayoutAlgorithms, alg);
			}
			return (index >= 0 ? this._availableLayoutParams[index] : []);
		},
		
		setLayoutAlgorithm: function(/*Object*/ alg, /*Object*/ subgraphId, /*Object*/ performLayout){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (!subgraphId && alg) {
				this._layoutAlgorithm = alg;
			}
			// 72208/38645:  Force relayout for subgraphs
			if (this._containsSubgraphs) {
				performLayout = true;
			}
			if (performLayout) {
				if (!subgraphId) {
					this.performLayout(true);
				} else {
					// layout the subgraph with subgraphId
				}
			}
		},
		
		getLayoutAlgorithm: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			return this._layoutAlgorithm;
		},

		setLayoutParams: function(/*Object*/ layoutParams, /*Object*/ subgraphId, /*Object*/ performLayout){			
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// layoutParams:
			//		Coming soon
			// subgraphId:
			//		Coming soon
			// performLayout:
			//		Coming soon
			
			if (!subgraphId && layoutParams) {
				this._layoutParams = layoutParams;
			}
			if (performLayout) {
				if (!subgraphId) {
					this.performLayout(true);
				} else {
					// layout the subgraph with subgraphId
				}
			}
		},

		setLayoutToCanvasBasedOnWidgetDef: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			var state = this.getSetDatasetState();
			if(this.widgetDefinition){
				var layoutAlgorithm = null;
				var layoutParamsArray = null;
				if (state) {
					layoutAlgorithm = state.stateData.layoutAlgorithm;
				    layoutParamsArray = state.stateData.layoutParams;
				} else {					
					var layout = this.widgetDefinition.getDefaultLayout();
					layoutAlgorithm = layout.algorithm;
					var layoutParams = this.getAvailableLayoutParams(layoutAlgorithm);
					layoutParamsArray = new Array(layoutParams.length);
					for (var i=0;i<layoutParams.length;i++) {
						layoutParamsArray[i] = new Array(3);
						if(layout[layoutParams[i][0]]){
							layoutParamsArray[i][0] = layoutAlgorithm; 
							layoutParamsArray[i][1] = layoutParams[i][0];
							layoutParamsArray[i][2] = layout[layoutParams[i][0]];
						} else {
							//Fill-in the default
							layoutParamsArray[i][0] = layoutAlgorithm;
								
							var params = layoutParams[i][1].split("|");		  
							layoutParamsArray[i][1] = layoutParams[i][0];
							layoutParamsArray[i][2] = params[0];
							layout[layoutParams[i][0]] = params[0];
						}
					}
				}
				this.setLayoutAlgorithm(layoutAlgorithm, null, false);
				this.setLayoutParams(layoutParamsArray, null, false); 
				
				// TODO: this._setRenderRelationshipsInsteadOfLinksOnFlexBridge(this.widgetDefinition.getRenderRelationshipsInsteadOfLinks());
				var labelStyle = this.widgetDefinition.getLabelStyle();
				if (!labelStyle) {
					labelStyle = "endEllipsis";
				}
				// TODO: this._setItemLabelStyleOnFlexBridge(labelStyle);
				
				//NOTE: We could eventually choose to make this configurable by widget def
				var keyboardNavigationPolicy = "nodesByHierarchy"; //nodesByConnection, nodesByHierarchy, none
				// TODO: this._setKeyboardNavigationPolicyOnFlexBridge(keyboardNavigationPolicy);
				
				//NOTE: Mainly used for some performance benchmarking, but could potentially be made part of widget def. The "basic" 
				//renderers are the default ones provided by ILOG as opposed to the "fancy" one we've made with icons, etc.
				// TODO:
				// this._setUseBasicNodeRendererOnFlexBridge(false); //Default should be false
				// this._setUseBasicLinkRendererOnFlexBridge(false); //Default should be false
				// this._setUseBasicSubgraphRendererOnFlexBridge(false); //Default should be false
			}
		},
		
        _setLayoutToCanvasBasedOnDataset: function() {  // bridgeDataset was passed in on flex Canvas, anything needed here?
			// summary:
			//		Set layout parameters based on dataset attributes for datasets and child datasets
			// description:
			//		Set layout parameters based on dataset attributes for datasets and child datasets
        	
			if (this.dataset) {
				// Override widget def layout with specific dataset parameters
				var layoutAlgorithm = this.dataset.getAttribute("layoutAlgorithm");			
				//Ramachandran - 08-Oct-2013 - 39073: Allow to define a maximum size of a node element in the topology view 
				var initialZoomLevel = this.dataset.getAttribute("initialZoomLevel");	
				// console.debug('initialZoomLevel', initialZoomLevel);
				
				if (layoutAlgorithm) {
					this.setLayoutAlgorithm(layoutAlgorithm, null, false);	
					var layout = this.parentPluggableView.getLayoutByName(layoutAlgorithm);
					if (layout) { //251593
						var layoutParams = this.getAvailableLayoutParams(layoutAlgorithm);
						var layoutParamsArray = new Array(layoutParams.length);
						var datasetLayoutParams = this.dataset.getAttribute("layoutParameters");					
						if (datasetLayoutParams){
							datasetLayoutParams = eval('('+datasetLayoutParams+')');
							for (var i=0;i<layoutParams.length;i++) {
								layoutParamsArray[i] = new Array(3);
								if (datasetLayoutParams[layoutParams[i][0]]) {
									layoutParamsArray[i][0] = layoutAlgorithm; 
									layoutParamsArray[i][1] = layoutParams[i][0];
									layoutParamsArray[i][2] = datasetLayoutParams[layoutParams[i][0]];
									layout[layoutParams[i][0]] = datasetLayoutParams[layoutParams[i][0]];
								} else {
									//Fill-in the default
									layoutParamsArray[i][0] = layoutAlgorithm;													
									var params = layoutParams[i][1].split("|");		  
									layoutParamsArray[i][1] = layoutParams[i][0];
									layoutParamsArray[i][2] = params[0];
									layout[layoutParams[i][0]] = params[0];
								}
							}						
							this.setLayoutParams(layoutParamsArray, null, false);
						}
					} else { 
						//251593 -- let's warn the deployer
						if (this._trace.isWarn()) {
							this._trace.warn("Dataset specifying layout algorithm (layoutAlgorithm = '" + layoutAlgorithm + "') not specified in original widget def. So, specified layout will be ignored.", "_setLayoutToCanvasBasedOnDataset");
						}
					}					
				}		
	
				// Set the appropriate layout algorithm and layout params to the subgraphs
				/* TODO:
				if (bridgeDataset.subgraphItemIds) {
					this._containsSubgraphs = true;
					for(var i=0;i<bridgeDataset.subgraphItemIds.length;i++){
						var item = this.dataset.getItem({itemId: bridgeDataset.subgraphItemIds[i]});
						if (item && item.isSubgraph()) {
							var alg = item.getAttribute("layoutAlgorithm");
							var datasetLayoutParams = item.getAttribute("layoutParameters");
							if(alg) {
								this.setLayoutAlgorithm(alg, item.getId(), false);						
								if(datasetLayoutParams){
									datasetLayoutParams = eval('('+datasetLayoutParams+')');
									var params = [];
									for(paramName in datasetLayoutParams){
										params.push([alg,paramName,datasetLayoutParams[paramName]]);
									}								
									this.setLayoutParams(params, item.getId(), false);						
								}						
							}
						}
					}
				}
				*/
				
				//Ramachandran - 08-Oct-2013 - 39073: Allow to define a maximum size of a node element in the topology view 
				if(initialZoomLevel) {
					setTimeout(dojo.hitch(this, this.setZoomLevel, initialZoomLevel ,false), 1000);
				}
			}
		},		
		
		performLayout: function(fitContentsAfterLayout){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			// switch on layout algorithm
			var alg = this.getLayoutAlgorithm();
			switch (alg) {		
				case "forceDirected":
					// this._doForceDirected();
					break;
				case "grid":
					// this._doGrid();
					break;	
				case "hierarchical":
					this._doHierarchical();
					break;					
				case "longLink":
					// this._doLongLink();
					break;					
				case "shortLink":
					// this._doShortLink();
					break;
				case "tree":
					this._doTree();
					break;						
				default:
					// we don't support this layout algorithm or it is unspecified					
			}
			if (fitContentsAfterLayout) {
				this.fitContents();
			}
		},		

		getRelatedItems: function(/*Object*/ item) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// item:
			//		Coming soon
			
			return this.inherited(arguments);
		},
		
		setEnabledObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds, /*Boolean*/enabled) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			// enabled:
			//      Coming soon

			if (enabled == undefined) {
				enabled = true;
			}
			// Ensure this is not on an event callback because this is often called due to user clicks on the 
			// status filter bar.  Setting graph items to be enabled/disabled will change rendering and that 
			// should not prevent quick return from a mouse event callback.
			setTimeout(dojo.hitch(this, this._setEnabledObjectIds, itemIds, linkIds, relationshipIds, enabled), 0);
		},
		
		_setEnabledObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds, /*Boolean*/enabled) {
			// Set the nodes from itemIds
			dojo.forEach(itemIds, function(id) {
				        var node;
						node = this._ilogDiagrammer.getGraphElementFromDataItem(this.dataset.getItem({itemId: id}));
						node.setDisabled(!enabled);
					}, this);
			// Set the links from linkIds
			dojo.forEach(linkIds, function(id) {
						// The ibm_ilog.diagram.widget.Diagram getGraphElementFromDataItem(item) lookup function looks up the
   			 			// store item first in the nodes store and then the links store, but it uses getIdentity(item) to do that
   			 			// and ibm.tivoli.navmodel.DatasetItemsStore throws an Error if the item is not in that store, so if 
   			 			// looking up a link, it will throw the Error when first checking the nodes store so we need to use
						// the direct function that looks up in the links store. (Could extend the nodes store to not throw
   			 			// the Error, but that might impact other views that use DatasetItemsStore.)
   			 			// TODO: Investigate if this can be changed in the store to return null instead of throw Error
						this._ilogDiagrammer._getLinkFromStoreItem(this.dataset.getLink({linkId: id})).setDisabled(!enabled);
					}, this);	
		},

		setAllEnabled: function(/*Boolean*/enabled) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// enabled:
			//      Coming soon
			
			if (enabled == undefined) {
				enabled = true;
			}
			// Ensure this is not on an event callback because this is often called due to user clicks on the 
			// status filter bar.  Setting graph items to be enabled/disabled will change rendering and that 
			// should not prevent quick return from a mouse event callback.
			setTimeout(dojo.hitch(this, this._setAllEnabled, enabled), 0);
		},
		
		_setAllEnabled: function(/*Boolean*/enabled) {
			// Only bother with this if we have a dataset
			if (this.dataset) {
				// Set all the nodes
				dojo.forEach(this._ilogDiagrammer.getGraph().getNodes(), function(node) {node.setDisabled(!enabled);});
				// Set all the links
				dojo.forEach(this._ilogDiagrammer.getGraph().getLinks(), function(link) {link.setDisabled(!enabled);});
			}
		},

		setZoomTo: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			
			this.inherited(arguments);
		},
		
		getNodeRectFromItemId: function(itemId, inClient) {
			// summary:
			//		Returns the bounding rectangle of a node of the graph associated with the dataste itemId,
			//		in client (i.e., browser page) coordinates, or relative to the canvas.
			// description:
			//		This method computes the bounding rectangle of a node contained in this canvas.
			//		The returned rectangle is either relative to the whole browser page (if inClient is true or omitted),
			//		or relative to the bounds of the canvas (if inClient is false).  If the itemId is not specified
			//      or cannot be found in the dataset (or the dataset is null), the rectangle returned is a one pixel
			//      rectangle at the canvas origin.
			// itemId: String
			//		The ID of a dataset item associated with a node in the graph
			// inClient: Boolean
			//		If true (the default), the returned rectangle is relative to the whole browser page.
			//		If false, the returned rectangle is relative to the bounds of the Diagram widget.
			// returns:
			//		An object with x, y, width and height properties.

			var rect = {x: 0, y: 0, width: 1, height: 1};
			var actualInClient = (arguments.length == 1 || inClient);
			var item = null;
			var node = null;
			if (this.dataset && (typeof itemId == "string")) {
				item = this.dataset.getItem({itemId: itemId});
			}
			if (item) {
				node = this._ilogDiagrammer.getGraphElementFromDataItem(item);
				
	        }
			if (node) {
				rect = this._ilogDiagrammer.getNodeRect(node, actualInClient);
			}
	        
			return rect;
	      },
		
		//********************************** Selection support ************************************************
		_createSelection: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Need our own selection object
			var kwArgs = {
					pluggableView: this
				};
			return new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection(kwArgs); 
		},

        _selectionChangedCallback: function(added, removed) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
        	// added: shape[]
        	// removed: shape[]
        	
            // For now, deal with only first selected item...i.e., assume single select of a node or a link
        	var selectedIds = [];
        	if (added.length == 0) {
        		if (this.selection.getItemCount() > 0 || this.selection.getLinkCount() > 0) {
        			this.selection.deselectAll();
        		}
        		else {
        			// check for getting notified twice?? Everything already unselected
        			// no op
        			// console.log(">> all items already deselected");
        		}
        	}
        	else {
        		// check for getting notified twice??
        		if (((added.length == 1) && (this.selection.getItemCount() == 1) && (added[0].getData().item.getId() == this.selection.getItems()[0].getId())) ||
        		   ((added.length == 1) && (this.selection.getLinkCount() == 1) && (added[0].getData().item.getId() == this.selection.getLinks()[0].getId())))
        		{
        			// no op
        			// console.log(">> item/link " + added[0].getData().item.getId() + " is already selected");
        		}
        		else {
        			if (added[0].TID == "N") {  
        				// console.log(">> selected node item is: " + added[0].getData().item.getId());
        				selectedIds.push(added[0].getData().item.getId());
        				this.selection.setSelectedObjectIds(selectedIds, null, null);
        			}
        			else if (added[0].TID == "L") {
        				// link selected, so deselect any nodes
        				// console.log(">> selected link is: " + added[0].getData().item.getId());
        				selectedIds.push(added[0].getData().item.getId());
        				this.selection.setSelectedObjectIds(null, selectedIds, null);        				
        			}   
                }
        	}
        },
		
		//**************************** double click support ******************************************************
        _doubleClickCallback: function(node, event) {

        	this._closeTooltip();
        	
        	var itemIds = [];
        	var linkIds = [];
        	var relationshipIds = [];
        	var objectId = node.getData().item.getId();
        	
        	if (node.TID == "N") {  // Is it a navmodel item?
        		itemIds.push(objectId);
        	}
        	else if (node.TID == "L") {  // Is it a graph link?
        		if (node.getData().item.getObjectType() == "link") {  // Is it a navmodel link? 
        			linkIds.push(objectId);
        		} 
        		else {  // It is a navmodel relationship
        			relationshipIds.push(objectId);
        		}
        	}
			var kwArgs = {
					itemIds: itemIds,
	    	    	linkIds: linkIds,
	    	    	relationshipIds: relationshipIds,
	    			dataset: this.dataset,
	    			pluggableView: this
				};
			var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(kwArgs);
			
			if(!this.daHelper){
				// Create DefaultActionHelper
				// By default creates the properties Dialog and launches it (via callback)
				this.daHelper = new ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper( 
						{
							defaultActionCallback: dojo.hitch(this, "_launchPropertiesDialog", objectContext)
						}
				);
			}
			// actually execute the default action/task (defined in constuctor)
			this.daHelper.executeDefaultAction(objectContext.getPluggableView());			
			
			// Fire the event
			this.onObjectDoubleClick(objectContext);
        },
                
    	_launchPropertiesDialog: function(/*Object*/ objectContext){
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
    		// objectContext:
    		//		Coming soon
    		
    		//NOTE: Reusing Anthony's MenuProviderHelper to launch the dialog to avoid duplicate logic. This is a temporary solution. 
    		var menuProviderHelper = new ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper();
    		menuProviderHelper.getMenuCommand("nwmi_PropertiesNotebookDialog", objectContext.getPluggableView(), null);
    	},        
        
		//**************************** context menu support ******************************************************   

		// 48183: Actions menu and context menu standard actions do not match standard actions available on the topology toolbar
		// Get the standard view tasks from the base class, and then if we have a toolbar, filter the list to match
    	// the standard view tasks available on the toolbar (in case the view widget definition filters out some tasks)
    	getViewSpecificTasks: function() {
    		// Get the base set of standard view tasks
            var viewTasks = this.inherited(arguments);
            // If we have a toolbar, check to filter the list of standard view tasks
            if (this.parentPluggableView._toolbar) {
            	// Get any toolbar rows from the widget definition
            	var tbRows = this.parentPluggableView.widgetDefinition.getToolbarRows();
            	if (tbRows.length > 0) {
            		// Build a CSV string of all the toolbar item types
                    var tbCmds = "";
                    for (var i=0; i < tbRows.length; i++) {
                       dojo.forEach(tbRows[i].contents, function(item) { tbCmds += (item.type + ","); });
                    }
                    // Filter out any standard view tasks that were not in the toolbar list
                    viewTasks = dojo.filter(viewTasks, function(task){ return tbCmds.indexOf(task[3]) >= 0;});
            	}
            }
            return viewTasks;
        },
        
    	_nodeContextCallback: function(node, event) {
    		this._closeTooltip(); 

			//create selection object  (might not need this here....check later for possible optimization)
			var objectContextArgs = {
					itemIds: this.selection.getItemIds(),
	    	    	linkIds: this.selection.getLinkIds(),
	    	    	relationshipIds: this.selection.getRelationshipIds(),
	    			dataset: this.dataset,
	    			pluggableView: this
				};
			var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(objectContextArgs);    		
    		
    	    // Copy (only on IE versions less than IE9 or if using quirks mode) and cache the event
    	    this._cxtMenuEvt = (dojo.isIE < 9 || (dojo.isIE && dojo.isQuirks)) ? dojo.mixin({}, event): event;   // 254234
    	    
    		var openMenuCallback = function(objContext) {  
    			// passing objContext in just in case we need it for tracing
    			
    		    // If a context menu is already open, close it because the selected context is likely different
    			if (this.contextMenu.getMenu()) {
    				this._openingNewMenu = true;
    				this._closeMenu();
    		    }
    	
    			//Open up the Dojo dijit.Menu
    			this.contextMenu.contextMenuOpen(this._cxtMenuEvt, this);
    			
    			// Listen for the onClose event to know when to hide the menu layer DIV
    			this._menuCloseHandle = dojo.connect(this.contextMenu.getMenu(), "onClose", this,
    													function() {
    														dojo.disconnect(this._menuCloseHandle);
    														if (this._openingNewMenu) {
    															this._openingNewMenu = false;
    														}
    													});
    			this._cxtMenuEvt = null;
    		};
    		
    		// Open the menu after this callback returns so as not to block the thread
			setTimeout(dojo.hitch(this, openMenuCallback, objectContext), 0);
    		
    		//Stop propagation of the event
    		dojo.stopEvent(event);
    	},
    	
    	_linkContextCallback: function(link, event) {
    		// processing is the same, so delegate to _nodeContextCallback
    		this._nodeContextCallback(link, event);
    	},
    	
    	_backgroundContextCallback: function(event) {
    		// processing is the same, so delegate to _nodeContextCallback
    		this._nodeContextCallback({}, event);    		
    	},
    	
    	_isMenuOpen: function() {		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
    		
    		return (this.contextMenu.getMenu()) ? true : false;
    	},    	
    	
    	//********************** Tooltip support ********************************************************************
	    getRolloverTarget: function() {
			// summary:
			//		Returns the graph entity under the mouse cursor in the canvas
			// description:
			//		This accessor returns the item (node), link, or relationship under the mouse
			//      cursor in the topology graph.  This can be used when overriding what is
			//      displayed in the tooltip for the entity.
			
			return this._rolloverTarget;
		},

	    getTooltip: function() {
			// summary:
			//		Returns the tooltip instance used for the canvas.
			// description:
			//		This accessor returns the ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip instance
			//      used to display tooltips for all entities in the topology graph.
			
			return this._tooltip;
		},
		
		_closeTooltip: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			if (this._rolloverTarget) {
				dojo.disconnect(this._propOnSetDatasetConnection);
				dojo.disconnect(this._propOnSetObjectsConnection);
				
				// Make sure we have a tooltip before trying to modify it
				if (this._tooltip) {
					// Clear out the reference in the tooltip to the content
					this._tooltip.updateContent(""); 
				}
				if (this._tooltipProperties){
					this._tooltipProperties.destroyRecursive();
					this._tooltipProperties = null;
				}
				
				// Make sure we have a tooltip before trying to hide it
				if (this._tooltip) {
					this._tooltip.unHover(this._ilogDiagrammer.domNode);
				}
				this._rolloverTarget = null;
				this._ilogDiagrammer.domNode.rolloverTargetRect = null;  
		    }
		},		
		
        _nodeMouseOverCallback: function(node, event) {
        	// add flag check as sometimes nodes get multipe mouseover events (i.e., handle only once)
            if (!node._hastooltip) {
            	node._hastooltip = 1;
            	
                // console.log(">>> mouse entering node: " + node.getLabel());
            	var objectId = node.getData().item.getId();
				var kwArgs = {
						itemIds: [objectId],
		    	    	linkIds: [],
		    	    	relationshipIds: [],
		    			dataset: this.dataset,
		    			pluggableView: this
					};
				var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(kwArgs);
				var boundsRect = this._ilogDiagrammer.getTooltipAroundPlacementFunction(node);
				
				//Let's fire the event (once we unwind this mouseover callback)
				setTimeout(dojo.hitch(this, this.onObjectRollOver, objectContext, boundsRect), 0);
            }
        },


        _nodeMouseOutCallback: function(node, event) {
            var p = this._ilogDiagrammer.getViewport().eventContentLocation(event);
            // Make sure we are really leaving the node and not just rolling over some inner shape of the node
            if (!node.hitTest(p, this._ilogDiagrammer.getGraph())) {
               // really leaving boundary
               // console.log("<<< mouse leaving node: " + node.getData().item.getLabel());
               var objectId = node.getData().item.getId();
               var kwArgs = {
            		   itemIds: [objectId],
            		   linkIds: [],
            		   relationshipIds: [],
            		   dataset: this.dataset,
            		   pluggableView: this
               };
               var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(kwArgs);
               
               //Let's fire the event (once we unwind this mouseout callback)
               setTimeout(dojo.hitch(this, this.onObjectRollOut, objectContext), 0);
               delete node._hastooltip;
            }
        },
        
        _linkMouseEnterCallback: function(link, event) {
        	// add flag check as sometimes links get multipe mouseover events (i.e., handle only once)
            if (!link._hastooltip) {
            	link._hastooltip = 1;
            	
                // console.log(">>> mouse entering link: " + link.getData().item.getLabel());
            	var objectId = link.getData().item.getId();
				var kwArgs = {
						itemIds: [],
		    	    	linkIds: [objectId],
		    	    	relationshipIds: [],
		    			dataset: this.dataset,
		    			pluggableView: this
					};
				var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(kwArgs);
				// var boundsRect = this._ilogDiagrammer.getTooltipAroundPlacementFunction(link);
				// use event coord to narrow down rect
				var boundsRect = {};
				boundsRect.x = event.clientX - 2;
				boundsRect.y = event.clientY - 2;
				boundsRect.width = 2;
				boundsRect.height = 2;
				
				//Let's fire the event (once we unwind this mouseover callback)
				setTimeout(dojo.hitch(this, this.onObjectRollOver, objectContext, boundsRect), 0);
            }
        },


        _linkMouseLeaveCallback: function(link, event) {
            var p = this._ilogDiagrammer.getViewport().eventContentLocation(event);
            // Make sure we are really leaving the node and not just rolling over some inner shape of the node
            if (!link.hitTest(p, this._ilogDiagrammer.getGraph())) {
               // really leaving boundary
               // console.log("<<< mouse leaving link: " + link.getData().item.getLabel());
               var objectId = link.getData().item.getId();
               var kwArgs = {
            		   itemIds: [],
            		   linkIds: [objectId],
            		   relationshipIds: [],
            		   dataset: this.dataset,
            		   pluggableView: this
               };
               var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(kwArgs);
               
               //Let's fire the event (once we unwind this mouseout callback)
               setTimeout(dojo.hitch(this, this.onObjectRollOut, objectContext), 0);
               delete link._hastooltip;
            }
        },
		
		_objectRollOverHandler: function(/*Object*/ objectContext, /*Object*/ boundsRect) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// objectContext:
			//		Coming soon
			// boundingInfo:
			//		Coming soon
			if (this._trace.isFinest()) {
				this._trace.finest("****** ROLL_OVER!!! itemIds = " + dojo.toJson(objectContext.getItemIds()) + 
						", linkIds = " + dojo.toJson(objectContext.getLinkIds()) + 
						", relationshipIds = " + dojo.toJson(objectContext.getRelationshipIds()) +
						"; boundingInfo = " + dojo.toJson(boundsRect));
			}
			
			// ignore if the menu is open or if we already have a rollover target
		    if (!this._isMenuOpen() && !this._rolloverTarget) {
		    	var aroundRect = {type: "rect"};
		    	if (objectContext.getItemCount() == 1) {
		    		this._rolloverTarget = objectContext.getItems()[0];
		    		dojo.mixin(aroundRect, boundsRect);
		    	} else if (objectContext.getLinkCount() == 1) {
		    		this._rolloverTarget = objectContext.getLinks()[0];
		    		aroundRect.x = boundsRect.x;
		    		aroundRect.y = boundsRect.y;
		    		aroundRect.width = aroundRect.height = 2;
		    	} else if (objectContext.getRelationshipCount() == 1) {
		    		this._rolloverTarget = objectContext.getRelationships()[0];
		    		aroundRect.x = boundsRect.x;
		    		aroundRect.y = boundsRect.y;
		    		aroundRect.width = aroundRect.height = 2;
		    	} else {
		    		this._rolloverTarget = "Unknown node or link";
		    		aroundRect.x = boundsRect.x;
		    		aroundRect.y = boundsrect.y;
		    		aroundRect.width = aroundRect.height = 1;
		    	}
		    	// adjust relative coordinates to absolute, and remove fractions
		    	/* still needed?
		    	var lt = dojo.coords(this._layerDiv, true);
		    	aroundRect.x += lt.x;
		    	aroundRect.y += lt.y;
		    	aroundRect.x = Math.round(aroundRect.x);
		    	aroundRect.y = Math.round(aroundRect.y);
		    	aroundRect.width = Math.ceil(aroundRect.width);
		    	aroundRect.height = Math.ceil(aroundRect.height);
		    	*/
				
		    	this._ilogDiagrammer.domNode.rolloverTargetRect = aroundRect;
		    	// make sure tooltip is not suppressed before displaying
		    	if (this._tooltip) {
		    		this._tooltip.hover(this._ilogDiagrammer.domNode);
		    	}
		    }
		},
		
		_objectRollOutHandler: function(/*Object*/ objectContext) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// objectContext:
			//		Coming soon
			if (this._trace.isFinest()) {
				this._trace.finest("****** ROLL_OUT!!! itemIds = " + dojo.toJson(objectContext.getItemIds()) + 
						", linkIds = " + dojo.toJson(objectContext.getLinkIds()) + 
						", relationshipIds = " + dojo.toJson(objectContext.getRelationshipIds()));
			}
			
			this._closeTooltip();
		},		
		
    	_customTooltip: function(/*Object*/ target) {
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
    		// target:
    		//		Coming soon

    		if (this._rolloverTarget) {
    			// target is this._ilogDiagrammer, so we use this._rolloverTarget
    			var content = "";
    			if (typeof this._rolloverTarget == "string") {
    				content = content + this._rolloverTarget;
    			} else {
    				content = content + this._rolloverTarget.getLabel();
    			}

    			//if the server side tooltip content is set, use this instead of defaults.
    			if (this._rolloverTarget.getTooltip) { //Need first test because getTooltip is not a function on child datasets right now
    				var tooltip = this._rolloverTarget.getTooltip();
    				if (tooltip){ 
    					content = tooltip;
    					return content;
    				}
    			}

    			if (this._tooltipProperties){
    				return this._tooltipProperties.getContent();
    			}

    			//create properties content object
    			this._tooltipProperties = new ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookGeneralTab({
    				id: this.id + "_tooltipProperties",
    				managingPluggableView: this, 
    				maxProperties: 3,  //TODO: ADM should probably be something a widgetDef sets.
    				_isTooltipProperties: true
    			});

    			//Call back for when the dataset it set
    			var objectType = (this._rolloverTarget.getObjectType) ? this._rolloverTarget.getObjectType() : null;
    			var setDatasetComplete = function(dataset) {
    				//connect to the onSetObjects Event
    				this._propOnSetObjectsConnection = dojo.connect(this._tooltipProperties, "onSetObjects", dojo.hitch(this, this._updateTooltipContent));

    				if (objectType === "item"){
    					this._tooltipProperties.setObjects([this._rolloverTarget], null, null, null);
    				} else if(objectType === "link"){
    					this._tooltipProperties.setObjects(null, [this._rolloverTarget], null, null);
    				} else if(objectType === "relationship"){
    					this._tooltipProperties.setObjects(null, null, [this._rolloverTarget], null);
    				} 
    			};
    			this._propOnSetDatasetConnection = dojo.connect(this._tooltipProperties, "onSetDataset", dojo.hitch(this, setDatasetComplete));
    			this._tooltipProperties.setDataset(this.dataset);

    			//return content;
    			return this._createTemporaryContentDiv(content, objectType);
    		}
    	},
    	
 	    //Event callback method to handle updating the tooltip content with updated content
 	    _updateTooltipContent: function(){
 		   // Make sure we have a tooltip first
 		   if (this._tooltip) {
 			   this._tooltip.updateContent(this._tooltipProperties.getContent(), this._ilogDiagrammer.domNode);
 		   }
 	    },
    	   
 	    _createTemporaryContentDiv: function(content, objectType) {		   
		   //Background div
		   var backgroundDiv = dojo.create("div",{
		   });
		   var processingPane = new dijit.layout.ContentPane({
			   content: backgroundDiv
		   });
			
			// text div		
		   var textDiv = dojo.create("div",{
			   "innerHTML": content
		   });
		   backgroundDiv.appendChild(textDiv);
		
		   if (objectType) {
			   // processing image div		
			   var processDiv = dojo.create("div",{
					"class": "processingImage"
			   });
			   backgroundDiv.appendChild(processDiv);
		   }

		   //Return
		   return processingPane;
	    },   
    	
		//********************** Events the canvas fires ************************************************************
		onObjectDoubleClick: function (/*Object*/ objectContext) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// objectContext:
			//		Coming soon
		},
		
		onObjectRollOver: function (/*Object*/objectContext, /*Object*/boundingRect) {
			this._objectRollOverHandler(objectContext, boundingRect);
		},
		
		onObjectRollOut: function (/*Object*/ objectContext) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// objectContext:
			//		Coming soon
			
			this._objectRollOutHandler(objectContext);
		},		
		
		//***************************** Handle graph layout algorithms *****************************************************

        _doHierarchical: function() {
        	dojo["require"]('ibm_ilog.graphlayout.hierarchical.HierarchicalLayout');    
        	var layout = new ibm_ilog.graphlayout.hierarchical.HierarchicalLayout();    
            var parmValue = null;
            for (var i=0; i < this._layoutParams.length; i++) {
 				switch (this._layoutParams[i][1]) {
					case "flowDirection":
 						switch (this._layoutParams[i][2]) {
 							case "right":
 								parmValue = ibm_ilog.graphlayout.Direction.RIGHT;
 								break;
 							case "left":
 								parmValue = ibm_ilog.graphlayout.Direction.LEFT;
 								break;
 							case "top":
 								parmValue = ibm_ilog.graphlayout.Direction.TOP;
 								break;		
 							case "bottom":
 								parmValue = ibm_ilog.graphlayout.Direction.BOTTOM;
 								break;								
 						}
 						layout.setFlowDirection(parmValue);
 						break; 				
 					case "levelJustification":
 						switch (this._layoutParams[i][2]) {
 							case "center":
 								parmValue = ibm_ilog.graphlayout.Direction.CENTER;
 								break;
 							case "left":
 								parmValue = ibm_ilog.graphlayout.Direction.LEFT;
 								break;
 							case "right":
 								parmValue = ibm_ilog.graphlayout.Direction.RIGHT;
 								break;
 							case "top":
 								parmValue = ibm_ilog.graphlayout.Direction.TOP;
 								break;		
 							case "bottom":
 								parmValue = ibm_ilog.graphlayout.Direction.BOTTOM;
 								break;								
 						}
 						layout.setLevelJustification(parmValue);
 						break;
 					case "levelingStrategy":
 						switch (this._layoutParams[i][2]) {
 							case "optimal":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.OPTIMAL;
 								break;
 							case "semi optimal":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.SEMI_OPTIMAL;
 								break;
 							case "higher levels":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.HIGHER_LEVELS;
 								break;
 							case "lower levels":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.LOWER_LEVELS;
 								break;		
 							case "spread out":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.SPREAD_OUT;
 								break;								
 						}
 						layout.setLevelingStrategy(parmValue);
 						break; 						
 					case "globalLinkStyle":
 						switch (this._layoutParams[i][2]) {
							case "polyline":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.POLYLINE_STYLE;
 								break;	
 							case "orthogonal":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.ORTHOGONAL_STYLE;
 								break;	 								
 							case "straight":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.STRAIGHT_LINE_STYLE;
 								break;
 							case "mixed":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.MIXED_STYLE;
 								break;	 								
 							case "no reshape":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.NO_RESHAPE_STYLE;
 								break;										
 						}
 						layout.setGlobalLinkStyle(parmValue);
 						break;
 					case "connectorStyle":
 						switch (this._layoutParams[i][2]) {
 							case "automatic":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.AUTOMATIC_PINS;
 								break;
 							case "centered":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.CENTERED_PINS;
 								break;			
 							case "evenly spaced":
 								parmValue = ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.EVENLY_SPACED_PINS;
 								break;								
 						}
 						layout.setConnectorStyle(parmValue);
 						break;
 					case "horizontalNodeOffset":
 						layout.setHorizontalNodeOffset(this._layoutParams[i][2]);
 						break;
 					case "horizontalLinkOffset":
 						layout.setHorizontalLinkOffset(this._layoutParams[i][2]);
 						break;
 					case "horizontalNodeLinkOffset":
 						layout.setHorizontalNodeLinkOffset(this._layoutParams[i][2]);
 						break; 		
 					case "verticalNodeOffset":
 						layout.setVerticalNodeOffset(this._layoutParams[i][2]);
 						break;
 					case "verticalLinkOffset":
 						layout.setVerticalLinkOffset(this._layoutParams[i][2]);
 						break;
 					case "horizontalNodeLinkOffset":
 						layout.setVerticalNodeLinkOffset(this._layoutParams[i][2]);
 						break; 			 						
 					default:
 				}        	   
            }
            
        	var onLayoutStepPerformedCallback = function(layoutStarted, layoutFinished) {
        		if (layoutFinished) {
        			var report = layout.getLayoutReport();
	                // console.debug("onLayoutStepPerformedCallback!!!!!! layoutStarted = " + layoutStarted + ", layoutFinished = " + layoutFinished + ", time = " + report.getLayoutTime());
	                if (this._makeNavWidgetTimer) {
						// console.debug("totalTime for makeNavWidget; " + this._makeNavWidgetTimer.stopAndGetTraceString());
					}
	                	
	                //AWE TODO
	                this.fitContents();
	                this.forceHideBusyPane();
        		}
        	};
           	dojo.connect(layout, "onLayoutStepPerformed", dojo.hitch(this, onLayoutStepPerformedCallback));
               
           // Don't use hardcoded values any longer
           // layout.setFlowDirection(8);
           // layout.setGlobalLinkStyle(2);
           this._ilogDiagrammer.set("nodeLayout", layout);
       },
           
       _doTree: function() {
           dojo["require"]('ibm_ilog.graphlayout.tree.TreeLayout');    
           var layout = new ibm_ilog.graphlayout.tree.TreeLayout();    
           var parmValue = null;
           for (var i=0; i < this._layoutParams.length; i++) {
				switch (this._layoutParams[i][1]) {
					case "layoutMode":
						switch (this._layoutParams[i][2]) {
							case "free":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.FREE;
								break;
							case "level":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.LEVEL;
								break;	
							case "tip over":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.TIP_OVER;
								break;
							case "tip leaves over":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.TIP_LEAVES_OVER;
								break;		
							case "tip roots over":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.TIP_ROOTS_OVER;
								break;
							case "tip roots and leaves over":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.TIP_ROOTS_AND_LEAVES_OVER;
								break;		
							case "radial":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.RADIAL;
								break;	
							case "alternating radial":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.ALTERNATING_RADIAL;
								break;								
						}
						layout.setLayoutMode(parmValue);
						break;
					case "flowDirection":
						switch (this._layoutParams[i][2]) {
							case "right":
								parmValue = ibm_ilog.graphlayout.Direction.RIGHT;
								break;
							case "left":
								parmValue = ibm_ilog.graphlayout.Direction.LEFT;
								break;
							case "top":
								parmValue = ibm_ilog.graphlayout.Direction.TOP;
								break;		
							case "bottom":
								parmValue = ibm_ilog.graphlayout.Direction.BOTTOM;
								break;								
						}
						layout.setFlowDirection(parmValue);
						break;
					case "globalLinkStyle":
						switch (this._layoutParams[i][2]) {
							case "straight":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.STRAIGHT_LINE_STYLE;
								break;
							case "no reshape":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.NO_RESHAPE_STYLE;
								break;		
							case "orthogonal":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.ORTHOGONAL_STYLE;
								break;		
							case "mixed":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.MIXED_STYLE;
								break;								
						}
						layout.setGlobalLinkStyle(parmValue);
						break;
					case "connectorStyle":
						switch (this._layoutParams[i][2]) {
							case "automatic":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.AUTOMATIC_PINS;
								break;
							case "centered":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.CENTERED_PINS;
								break;			
							case "evenly spaced":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.EVENLY_SPACED_PINS;
								break;								
						}
						layout.setConnectorStyle(parmValue);
						break;
					case "globalAlignment":
						switch (this._layoutParams[i][2]) {
							case "center":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.CENTER;
								break;
							case "border center":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.BORDER_CENTER;
								break;
							case "east":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.EAST;
								break;					
							case "west":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.WEST;
								break;			
							case "tip over":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.TIP_OVER;
								break;								
							case "tip over west":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.TIP_OVER_WEST;
								break;		
							case "tip over east west":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.TIP_OVER_EAST_WEST;
								break;			
							case "tip over both sides":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.TIP_OVER_BOTH_SIDES;
								break;				
							case "mixed":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.MIXED;
								break;								
						}
						layout.setGlobalAlignment(parmValue);
						break;
					case "levelAlignment":
						switch (this._layoutParams[i][2]) {
							case "center":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.CENTER;
								break;
							case "north":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.NORTH;
								break;	
							case "south":
								parmValue = ibm_ilog.graphlayout.tree.TreeLayout.SOUTH;
								break;								
						}
						layout.setLevelAlignment(parmValue);
						break;
					case "aspectRatio":
						if (this._layoutParams[i][2] == "1") {
							layout.setAspectRatio(1);
						} else {
							layout.setAspectRatio(this._layoutParams[i][2]);
						}
						break;
					default:
				}        	   
           }
           
           var onLayoutStepPerformedCallback = function(layoutStarted, layoutFinished) {
        	   if (layoutFinished) {
        		   var report = layout.getLayoutReport();
        		   // console.debug("onLayoutStepPerformedCallback!!!!!! layoutStarted = " + layoutStarted + ", layoutFinished = " + layoutFinished + ", time = " + report.getLayoutTime());
        		   if (this._makeNavWidgetTimer) {
        			   // console.debug("totalTime for makeNavWidget; " + this._makeNavWidgetTimer.stopAndGetTraceString());
        		   }
            	
        		   //AWE TODO
        		   this.fitContents();
        		   this.forceHideBusyPane();
        	   }
           };
           dojo.connect(layout, "onLayoutStepPerformed", dojo.hitch(this, onLayoutStepPerformedCallback));
              
           // Default tree layout is flowDirection RIGHT with straight lines
           // layout.setLayoutMode(ibm_ilog.graphlayout.tree.TreeLayout.ALTERNATING_RADIAL);    
           // layout.setGlobalLinkStyle(2);
               
           //AWE TODO
           this._ilogDiagrammer.set("nodeLayout", layout);
       },
           
       //AWE TODO
       /**
        * Performs a layout on the server.
        */
       _serverLayout: function(graph, nodeLayout, linkLayout) {
           	//setStatus("");
           	graph.setNodeLayout(nodeLayout);
           	graph.setLinkLayout(linkLayout);
           	var url = "/sample-graphlayout/graphlayout"; //AWE TODO dijit.byId("serverUrl").value;
           	var serverLayout = new ibm_ilog.diagram.graphlayout.ServerSideLayout(graph,url);    
           	var start = new Date().getTime();
           	var deferred = serverLayout.layout();
           	deferred.addErrback(function(value) {
           		if (value.status == 404) {
           			//setStatusError("Unable to find server-side layout code at URL: " + url);
           		}
           		else {
           			//setStatusError(value);
           		}
           	});
           	deferred.addCallback(function(value){
           		var end = new Date().getTime();
           		var duration = end-start;
           		//("Layout on server completed in " + duration + " ms");
               });
       },
           
       doForceDirected: function() {
           dojo["require"]('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');    
           var layout = new ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout();    
           layout.setLayoutMode(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.FAST_MULTILEVEL_MODE);    
           layout.setMaxRepeatForConvergence(3);
           this._ilogDiagrammer.set("nodeLayout", layout);
           this.fitContents();
       },
		
       //AWE TODO
       _buildSampleNodesJson: function(nodeCount) {
    	   var nodes = {};
    	   nodes.identifier = "id";
    	   nodes.label = "id";
    	   nodes.items = [];
    	   for (var i = 0; i < nodeCount; i++) {
    		   var node = {};
    		   node.id = i.toString();
    		   nodes.items.push(node);
    	   }
    	   return nodes;
       },
       
       _buildSampleLinksJson: function (nodeCount, linkPerNodeCount) {
    	   var links = {};
    	   links.identifier = "id";
    	   links.label = "id";
    	   links.items = [];

    	   var currentLevel = 0;
    	   var processedNodeCount = 1;
    	   while (processedNodeCount < nodeCount) {
    		   for (var i = 0; i < linkPerNodeCount; i++) {
    			   var link = {};
    			   link.id = currentLevel + "_" + processedNodeCount;
    			   link.identity1 = currentLevel.toString();
    			   link.identity2 = processedNodeCount.toString();
    			   links.items.push(link);
            		
    			   processedNodeCount++;
    		   }
    		   currentLevel++;
    	   }
    	   return links;
       },
       
       _myLinkTemplate: 
	          "[{"+
	          "    dojoAttachPoint: '_path',"+
	          "    shape: {"+
	          "        type: 'polyline',"+
	          "        points: [{x: 0,y: 0}, {x: 100,y: 0}]"+
	          "    },"+
	          "    stroke: {"+
	          "        width: {{strokeWidth}}," +
	          "        color: '{{strokeColor}}'" +
	          "    },"+
	          "    selectedStyle: {"+
	          "        stroke: { 'width': 5, 'color': '{{selectedStrokeColor}}' }"+
	          "    }"+	          
	          "}, {"+
	          "    dojoAttachPoint: '_endArrow',"+
	          "    shape: {"+
	          "        type: 'polyline',"+
	          "        points: [{x: -8,y: 4}, {x: 0,y: 0}, {x: -8,y: -4}]"+
	          "    },"+
	          "    fill: '{{arrowColor}}',"+
	          "    selectedStyle: {"+
	          "        fill: '{{selectedArrowColor}}' "+
	          "    }"+	          
	          "},"+
	          "{"+
	          "    isDecoration: true,"+
	          "	   position: 0.5,"+
	          "    distance:5,"+
	          "    positionType: ibm_ilog.diagram.LinkDecorationPositionType.Relative,"+
	          "    orthogonalAlignment: ibm_ilog.diagram.LinkDecorationOrthogonalAlignment.Left,"+
	          "    parallelAlignment: ibm_ilog.diagram.LinkDecorationParallelAlignment.Middle,"+
	          "    children: [{"+
	          "       shape: {"+
	          "          type: 'text',"+
	          "          text: '{{linkLabel}}',"+
	          "          y: 10,"+
	          "          align: 'start'"+
	          "       },"+
	          "       fill: 'black',"+
	          "       font: {"+
	          "          family: 'sans-serif',"+
	          "          size: 10"+
	          "       }"+            	
	          "    }]"+
	          "}]",
		                   	          
	     /* MAA TODO */
		 _myNodeTemplate:
	    	 "{"+
		     "	 layout: { type:'ibm_ilog.diagram.gfxlayout.GridLayout',"+
             "             cols: [{width:29}, {width:83}, {width:29}],"+
             "             rows: [{height:29}, {height:29}, {height:29}, {height:29}]"+
             "     },"+
		     "	 children: ["+
		     "	     {"+
		     "	         dojoAttachPoint: 'baseShape',"+
             "           column:0, row:0, colspan:-1, rowspan:-1,"+
		     "	         minimumSize:{width:141, height:117},"+
		     "	         shape: { width:1, height:1, r: 5, type:'rect'},"+
		     "	         fill: '{{statusFill}}', "+
		     "	         stroke: {'color': '{{statusColor}}', 'width': 2 },"+
             "           selectedStyle: {"+
		     "                stroke: { 'width': 5, 'color': '{{selectedStrokeColor}}' }"+
		     "           }"+		     
		     "	    },"+
		     "      {"+
		     "         dojoAttachPoint: 'nodeIcon',"+
             "         column:0, row:0, rowspan:-1, colspan:-1,"+
		     "         valign: 'top', halign: 'center',"+
		     "         margins: [32, 20, 32, 32],"+
             "         children: [{shape: {type:'text', text:''}}]"+
		     "      },"+
		     "      {"+
		     "         dojoAttachPoint: 'statusIcon1',"+
             "         column:3, row:0,"+
		     "         margins: [0, 3, 3, 0],"+
		     "         children: [{shape: {type:'text', text:''}}]"+
		     "      },"+
		     "	    {"+
		     "	       dojoAttachPoint: 'textBackgroundShape',"+
             "         column:0, row:3, colspan:-1,"+
		     "         valign: 'bottom',"+
		     "	       margins:[0,0,0,0],"+
		     "	       shape: {type:'rect', width:1, height:28, r: 5},"+
             "	       stroke: {'color': '{{statusColor}}', 'width': 1 },"+
		     "	       fill:{type:'pattern', x:0, y:0, width:2, height:39, src:'gradient2.PNG'},"+	
             "         selectedStyle: {"+
		     "              stroke: { 'width': 5, 'color': '{{selectedStrokeColor}}' }"+
		     "         }"+		     
		     "	    },"+
		     "	    {"+
		     "	       dojoAttachPoint: 'textShape',"+
             "         column:0, row:3, colspan:-1,"+
		     "         valign: 'center', halign: 'center',"+
		     "	       margins:[2,2,2,2],"+
		     "	       shape: {type:'text', text:'{{label}}', align:'middle'},"+
		     "	       fill:'{{textColor}}',"+
		     "	       font:{type:'font', size:'10pt', family:'sans-serif'}"+
		     "	    }"+
		     "	 ]"+
		     "}",
	     /* */

         _getNodeTemplate: function(item, store, diagram) {
           // return this._myNodeTemplate;
             return this._nodeTemplate;
         },
         
         _getLinkTemplate: function(){
             // return this._myLinkTemplate;
             return this._linkTemplate;
         },
         
		 _onLinkCreated: function(link, start, end, diag){
			 this._connectionHandles.push(dojo.connect(link, "onPropertyChanged", null, dojo.hitch(this, this._linkPropertyChanged, link)));
        	 var storeItem = diag.getBoundItem(link);
        	 var style = storeItem.getLinkStyle();
             link.setLinkLabel(this.showLablesOnLinks ? storeItem.getLabel() : ""); 
        	 link.setStrokeWidth((!style || !style.getLineWidth()) ? 2 : style.getLineWidth());
        	 link.setStrokeColor((!style || !style.getLineColor()) ? "black" : style.getLineColor());
        	 link.setArrowColor((!style || !style.getArrowColor()) ? "black" : style.getArrowColor());
         },
         
         _linkPropertyChanged: function(link, property, oldValue, newValue) {
             if (property == "disabled") {
            	 if (newValue != oldValue) {
            		 // change link appearance to enabled or disabled
            		 this._changeLinkDisabledRendering(link, newValue);
            	 }
             }
         },         
         
         _changeLinkDisabledRendering: function(link, disabled) {
        	 // change color alpha values, icons, and selectable state
        	 var sColor = link._path.getStroke().color;
        	 var fColor = link._endArrow.getFill();
        	 
        	 // Change alpha vlaues of line color and arrow color
        	 if (disabled) {
        		 sColor.a = 0.1;
        		 fColor.a = 0.1;
        	 }
        	 else {
        		 sColor.a = 1;
        		 fColor.a = 1;
        	 }
        	 link.setStrokeColor(sColor);
        	 link.setArrowColor(fColor);
        	 
        	 // Set the link to be non-selectable when disabled
        	 link.setSelectable(!disabled);
         },
         
         _onNodeCreated: function(node, diag){
        	 this._connectionHandles.push(dojo.connect(node, "onPropertyChanged", this, dojo.hitch(this, this._nodePropertyChanged, node)));
        	 var storeItem = diag.getBoundItem(node);
        	 var statuses = storeItem.getStatuses({mergeWidgetDef: false});
        	 if (statuses && statuses.length > 0) {
        		 var status = statuses[0];
        		 //Get background image info
        		 var label =  status.getLabel();
        		 var tooltip =  status.getTooltip();
        		 node.setStatus(label);
        		 node.setStatusColor(status.getColor());
        		 node.setStatusImage(this._getNodeImageFromCache(this._getStatusIconPath(status, true)));
        		 var scalarImageFileName = status.getScalarImage();
        		 scalarImageFileName = scalarImageFileName.substring(scalarImageFileName.indexOf("st64_"));
        		 var statusFillKey = scalarImageFileName.slice(0,scalarImageFileName.indexOf("."));  // key is the name of the status image file, minus .json extension
        		 if (this._nodeStatusFillCache.containsKey(statusFillKey)) {
        			 node.setStatusFill(this._nodeStatusFillCache.item(statusFillKey));
        		 }
        		 else {
        			 node.setStatusFill(this._nodeStatusFillCache.item(this._NO_STATUS_KEY)); 
        		 }
        	 }
        	 else {
        		 node.setStatusColor("#B2B2B2");
        		 node.setStatusFill(this._nodeStatusFillCache.item(this._NO_STATUS_KEY));
        	 } 
        	 
        	 // TODO: This is a lot of JSON data to store in the node property...look for alternative
        	 node.setLargeImage(this._getNodeImageFromCache(this._getNodeIconPath(storeItem.getItemStyle(), true)));
         },

        _nodePropertyChanged: function(node, property, oldValue, newValue) {
             if (property == "largeImage") {
                node.nodeIcon.clear();
                dojox.gfx.utils.deserialize(node.nodeIcon, newValue);
             }
             else if (property == "statusImage") {
                node.statusIcon1.clear();
                dojox.gfx.utils.deserialize(node.statusIcon1, newValue);
             }
             else if (property == "statusFill") {
            	 node.baseShape.setFill(newValue);
             }
             else if (property == "disabled") {
            	 if (newValue != oldValue) {
            		 // change node appearance to enabled or disabled
            		 this._changeNodeDisabledRendering(node, newValue);
            	 }
             }
         },
         
         _changeNodeDisabledRendering: function(node, disabled) {
        	 // change color alpha values, icons, and selectable state
        	 var sColor = node.baseShape.getStroke().color;
        	 var tColor = node.textShape.getFill();
        	 // Change alpha values of border status color and text color
        	 if (disabled) {
        		 sColor.a = 0.1;
        		 tColor.a = 0.1;
        	 }
        	 else {
        		 sColor.a = 1;
        		 tColor.a = 1;
        	 }
        	 node.setStatusColor(sColor);
        	 node.setTextColor(tColor);
        	 
        	 // Change the alpha values of the status color background fill gradient
        	 var statusFill = dojo.mixin({}, node.baseShape.getFill());  // copy the fill
        	 var fcolor = null;
        	 if ("colors" in statusFill) {
        		 // gradient fill
        		 dojo.forEach(statusFill.colors, function(colorStop) {colorStop.color.a = (disabled ? 0.1 : 1);});
        	 }
        	 else {
        		 // simple color fill
        		 statusFill.a = (disabled ? 0.1 : 1);
        	 }
        	 node.setStatusFill(statusFill);
        	 
        	 var storeItem = this._ilogDiagrammer.getBoundItem(node);
        	 // Change node icon
        	 node.setLargeImage(this._getNodeImageFromCache(this._getNodeIconPath(storeItem.getItemStyle(), !disabled)));
        	 
        	 // Change status icon
        	 var statuses = storeItem.getStatuses({mergeWidgetDef: false});
        	 if (statuses && statuses.length > 0) {
        		 var status = statuses[0];
        		 node.setStatusImage(this._getNodeImageFromCache(this._getStatusIconPath(status, !disabled)));
        	 }
        	 
        	 // Set the node to be non-selectable when disabled
        	 node.setSelectable(!disabled);      	 
         },         
         
         _getNodeIconPath: function(itemStyle, enabled) {
        	 if (enabled == undefined) {
        		 enabled = true;
        	 }
             var imagePath = this._cleanUpImagePath(itemStyle.getScalarImage().replace(".swf",".json"));
             // If we need the disabled icon, first make sure the imagePath name is in the normal iconName1.json format
             if (!enabled && (imagePath.indexOf("1.json") > 0)) {
            	 imagePath = imagePath.replace("1.json", "2.json");
             }
        	 return imagePath;
         },
         
         _getStatusIconPath: function(status, enabled) {
        	 if (enabled == undefined) {
        		 enabled = true;
        	 }
             var imagePath = this._cleanUpImagePath(status.getScalarImage().replace(".swf",".json"));
             // If we need the disabled icon, change the file name to iconName2.json
             if (!enabled) {
            	 imagePath = imagePath.replace(".json", "2.json");
             }
        	 return imagePath;
         },         

        _getNodeImageFromCache: function(imagePath) {
        	 var content = {};
             if (!this._nodeImageCache.containsKey(imagePath)) {
                dojo.xhrGet(
                   {url: imagePath,
                   content: content,
                   handleAs: "json",
                   sync: true,
                   load: dojo.hitch(this, function(result, ioArgs) {this._nodeImageCache.add(ioArgs.args.url, result); }),
				       error: dojo.hitch(this, function(error, ioArgs){
                            this.forceHideBusyPane();   // just in case
                            console.error(error);
					        var exc = ibm.tivoli.navmodel.Utils.getException(error, ioArgs, "_getNodeImageFromCache", this._trace, this.dataset.getVersion());
					        this.displayException(exc);
				           })
			        });
             }
             return this._nodeImageCache.item(imagePath);
         },
         
         _initNodeStatusFillCache: function() {
        	 // All linear gradient fills change only vertically down from white to final color
        	 // For consistency, use scalarImage standard filenames as the keys 
        	 this._nodeStatusFillCache.add(this._NO_STATUS_KEY, "#f8f8f8");
        	 this._nodeStatusFillCache.add("st64_fatal", {type:"linear", x1:0, y1:0, x2:0, y2:80, colors: [{offset: 0, color: "#ffffff"}, {offset: 1, color: "#c2c2c2"}]});
        	 this._nodeStatusFillCache.add("st64_critical", {type:"linear", x1:0, y1:0, x2:0, y2:80, colors: [{offset: 0, color: "#ffffff"}, {offset: 1, color: "#ffb8b8"}]});
        	 this._nodeStatusFillCache.add("st64_warning_major", {type:"linear", x1:0, y1:0, x2:0, y2:80, colors: [{offset: 0, color: "#ffffff"}, {offset: 1, color: "#ffdb99"}]});
        	 this._nodeStatusFillCache.add("st64_warning", {type:"linear", x1:0, y1:0, x2:0, y2:80, colors: [{offset: 0, color: "#ffffff"}, {offset: 1, color: "#ffffc7"}]});
        	 this._nodeStatusFillCache.add("st64_informational", {type:"linear", x1:0, y1:0, x2:0, y2:80, colors: [{offset: 0, color: "#ffffff"}, {offset: 1, color: "#d4f1ff"}]});
        	 this._nodeStatusFillCache.add("st64_normal", {type:"linear", x1:0, y1:0, x2:0, y2:80, colors: [{offset: 0, color: "#ffffff"}, {offset: 1, color: "#c6f2b8"}]});
        	 this._nodeStatusFillCache.add("st64_unknown", {type:"linear", x1:0, y1:0, x2:0, y2:80, colors: [{offset: 0, color: "#ffffff"}, {offset: 1, color: "#ffffff"}]});
         }
	 });

});
