/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/dashboard/ResourceGroup", [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/xhr",
	"dojo/i18n!./nls/DashbarResources"
], function (declare, lang, xhr, mri) {
	return declare([], {
		//component name for this group
		name : "",

		label : "",

		widgetPathKey : "",
		
		widgetPath : "",

		widgetID : "",

		dataSetID : null,

		groupSourceToken : 0,

		groupID : "",

		topperLinks : null,

		selected : false,

		loadingLabel : "",

		overallStatus : "",

		normalImage : "",

		selectorHome : null,

		hasSelector : false,

		groupStatus : 0,

		groupCount : 0,

		groupOID : 0,

		//resource bundle
		_resources : mri,

		/**
		 * Creates a resource group.
		 * 
		 * @constructor
		 * @param args
		 */
		constructor : function (args) {
			lang.mixin(this, args);
			if (this.hasSelector) {
				this.selectorHome = this.dataSetID;
			}
		},

		postMixInProperties : function () {
			// summary:  set nls strings
			// tags: private
			this.loadingLabel = this._resources.Loading;
			this.inherited(arguments);
		},

		getLabel : function () {
			return this.label;
		},

		getWidgetID : function () {
			return this.widgetID;
		},

		getWidgetPathKey : function () {
			return this.widgetPathKey;
		},
		
		getWidgetPath : function () {
			return this.widgetPath;
		},

		getTopperLinks : function () {
			return this.topperLinks;
		},

		/**
		 * fetch the group memebers count
		 */
		fetchGroupMembersCountForUpdate : function () {

			var xhrArgs = {
				url : '/ibm/tivoli/rest/providers/USMI/datasets/GROUP:' + this.groupID,
				handleAs : "json",
				preventCache : true
			};

			var handler = xhr.get(xhrArgs);
			return handler;
		},

		getGroupCount : function () {
			return this.groupCount;
		},

		setGroupCount : function (count) {
			this.groupCount = count;
		},

		getGroupStatusValue : function () {
			if (this.groupStatus) {
				return this.groupStatus.getValue();
			} else {
				return 5; //Unknown
			}
		},

		getGroupStatus : function () {
			return this.groupStatus;
		},

		setGroupStatus : function (status) {
			this.groupStatus = status;
		},

		getGroupOID : function () {
			return this.groupOID;
		}

	});
});
