/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

define("ibm/usmi/widgets/PropertyNotebookGeneralTab", ["dojo/_base/kernel",
        "dojo/_base/declare",
        "dijit/_WidgetBase",
        "dojo/dom-style",
        // TWL imports
        "ibm/tivoli/tip/navwidget/properties/dijit/PropertiesNotebookGeneralTab"
],
    function (dojo, declare, _WidgetBase, style, PropertiesNotebookGeneralTab) {


    return declare([PropertiesNotebookGeneralTab], {

        postCreate: function(){
            // summary:
            //         Called after a widget's dom has been setup
            // tags:
            //        protected

            //Call superclass
            this.inherited(arguments);

            //THIS is the whole reason for this class.  In order to override the prop notebook gen tab
            //to properly scroll with a lot of content, we need to override this and provide the style.
            //This is an exception where we are loading a widget that we dont own and it inherits our style
            //(overflow hidden) that we actually dont want.
            style.set(this._generalTab.domNode, "overflow", "auto");
        }

    });
});
