require({cache:{
'url:ibm/usmi/widgets/templates/TaskCategory.html':"<div tabindex=\"${tabIndex}\" class=\"taskCategory\" data-dojo-attach-point=\"mainNode\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012, 2013 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n\t<div class=\"taskCategoryBar\">\r\n       <!-- aria-level defines the hierarchical level of an element within a structure -->\r\n\t   <div class=\"taskCategoryTitle\" data-dojo-attach-point=\"titlePoint\" role=\"heading\" aria-level=\"2\" ></div>\r\n\t</div>\r\n\t<div data-dojo-attach-point=\"containerNode\"></div>\r\n</div>"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/widgets/TaskCategory", [
    "dojo/_base/declare",
    "dojo/keys",
    "dojo/_base/array",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dojo/text!./templates/TaskCategory.html",
    "dijit/_KeyNavContainer",
    "dijit/_Contained",
    // NextGen imports
    "ibm/usmi/widgets/TaskLink"
], function(declare, keys, array, _WidgetBase, _TemplatedMixin, TaskCategoryTemplate, _KeyNavContainer, _Contained,
        TaskLink) {
    // module:
    //      ibm/usmi/widget/TaskCategory
    // summary:
    //      The TaskCategory is a container for the drawer tasks of the Details Selector 
    //      The details selector template hierarchy  TaskPane->TaskCategory->TaskLink
    //      It has a header describing the TaskLink under it.  It has a tabindex and mixins _KeyNavContainer
    //      so users can tab into each TaskCategory and then use keyboard up / down arrows for navigation
    return declare([
        _WidgetBase,
        _TemplatedMixin,
        _KeyNavContainer,
        _Contained
    ], {

        // Template info
        templateString: TaskCategoryTemplate,

        label: "",
        task: "",
        visible: true,

        startup: function() {
            this.inherited(arguments);

            // key nav container
            this.startupKeyNavChildren();
        },

        postCreate: function() {
            this.inherited(arguments);

            // key nav container
            this.connectKeyNavHandlers([ keys.UP_ARROW
            ], [ keys.DOWN_ARROW
            ]);
        },

        buildRendering: function() {
            this.inherited(arguments);
            this.titlePoint.innerHTML = this.label;
        },

        addLink: function(link) {
            if (link instanceof TaskLink) {
                this.addChild(link);
            } else {
                this.addChild(new TaskLink(link));
            }
        },

        updateLinks: function(categoryUpdate) {
            if (!categoryUpdate) {
                return;
            }
            var _links = this.getChildren();
            array.forEach(_links, function(link) {
                link.update(categoryUpdate[link.link]);
            });
        },

        /*
         * Returns ibm.usmi.widgets.TaskLink widget.
         */
        getLink: function(/*String*/link) {
            var subset = array.filter(this.getChildren(), function(/*Widget*/child) {
                return child.isInstanceOf(TaskLink) && child.link === link;
            }, this);
            return (subset && subset[0]) || null;
        },

        removeLink: function(/*String*/link) {
            var widget = this.getLink(link);
            if (widget) {
                this.removeChild(widget);
            }
        },

        _setVisibleAttr: function(visible) {
            this.visible = visible;
            this.mainNode.style.display = (visible) ? "" : "none";
        },

        _getVisibleAttr: function() {
            return this.visible;
        }

    });
});