require({cache:{
'url:ibm/usmi/widgets/templates/TreeTopperLink.html':"<a class=\"topperLink topperLinkAnchor\" data-dojo-attach-point=\"topperAnchor\" role=\"link\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n\t<div class=\"pad5t pad10l\">\r\n\t      <img class=\"topperLinkIcon sprite\" data-dojo-attach-point=\"iconAttachPoint\"></img>\r\n\t      <div class=\"topperLinkLabel\" data-dojo-attach-point=\"labelAttachPoint\"></div>\r\n\t</div>\r\n</a>\r\n"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/widgets/TreeTopperLinks", [
    "dojo/_base/kernel",
    "dojo/_base/declare",
    "dojo/dom-attr",
    "dojo/keys",
    "dojo/topic",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dojo/text!./templates/TreeTopperLink.html",
    "dijit/focus",
    "dojo/_base/event", // event.stop
    // NextGen imports
    "ibm/usmi/util/BaseWidget",
    "ibm/usmi/widgets/util/TextAbbr",
    "ibm/usmi/widgets/util/Constants",
    "ibm/usmi/core/utils/Logger"
], function(dojo, declare, attr, keys, topic, _WidgetBase, _TemplatedMixin, TreeTopperLinkTemplate, focus, event, BaseWidget,
        TextAbbr, Constants, Logger) {

    return declare([
        _WidgetBase,
        _TemplatedMixin,
        BaseWidget
    ], {

        // Template info
        templateString: TreeTopperLinkTemplate,

        showDelay: 10,
        
        rootId: "",

        topperId: "",

        /**
         * NLS translated label for this node which the user will see
         * 
         * @param
         */
        label: "",

        /**
         * fully qualified class name of a 16x16 pixel icon to display by this
         * node
         * 
         * @param
         */
        icon: "",

        // widget id specified to be will be sent out in topic.publish when link is selected
        taskWidgetId: "",

        // path key for widget specified to be will be sent out in topic.publish when link is selected
        taskWidgetPathKey: "",

        // path  for widget specified to be will be sent out in topic.publish when link is selected
        taskWidgetPath: "",

        textAbbr: null,

        _imagePath: null,

        // Image Path
        IMAGE_PATH: "ibm/usmi/widgets/themes/toppers/images/",

        /**
         * Whether this link will attempt to pre-select itself when initialzied.
         * Only one link can be selected at a time but multiple can try... only
         * one will succeed. Use with care
         * 
         * @public
         */
        selected: false,

        // the logger
        _treeTreeToppersLogger: new Logger("ibm.usmi.widgets", "TreeTopperLinks"),

        constructor: function() {
            this._imagePath = require.toUrl(this.IMAGE_PATH);
        },

        postCreate: function() {
            this.inherited(arguments);
            this.connect(this.topperAnchor, Constants.ON_CLICK, this._handleClick);
            this.connect(this.topperAnchor, Constants.ON_KEYPRESS, this._handleKeypress);
        },

        _handleKeypress: function(/*Event*/evt){
            // summary:
            //      Handler for keyboard events
            // description:
            // tags:
            //      private
            
            if (evt.charOrCode === keys.ENTER || evt.charOrCode === keys.SPACE || evt.charOrCode === " ") {
                // Use setTimeout to avoid crash on IE, see #10396.
                 this._showTimer = setTimeout(lang.hitch(this, function(){
                    this._handleClick(evt);
                }), this.showDelay);
                
                event.stop(evt);     
            }
        },
        
        startup: function() {
            this.inherited(arguments);

            // check window location's hash to determine whether this link should be selected
            if (this.getUrlHashParm(Constants.HASH_TOPPER_SELECTION) === this.topperId) {
                this.selected = true;
            }

            this.update();
        },

        buildRendering: function() {
            this.inherited(arguments);
        },

        update: function(args) {
            dojo.mixin(this, args);
            this.updateLabel();
            this.updateIcon();
            this.selectionCheck();

        },

        updateIcon: function() {
            // currently setting complete path in dashbar.json, doing it that way for future
            // toppers can point to images outside topper path
            attr.set(this.iconAttachPoint, "src", this.icon);
            attr.set(this.iconAttachPoint, "aria-role", "presentation");

        },

        updateLabel: function() {
            var formattedLabel = this.label;

            //update the textAbbr if it exists
            if (this.textAbbr) {
                this.textAbbr.update(formattedLabel);
            } else {//create textAbbr
                this.textAbbr = new TextAbbr({
                    text: formattedLabel,
                    maxLength: 34,
                    format: Constants.ABBREV_KEEP_COUNT
                }, this.labelAttachPoint);
            }
        },

        focus: function() {
            focus.focus(this.topperAnchor);
        },

        getLabel: function() {
            return this.label;
        },

        select: function(select) {
            this.selected = select;
            dojo.toggleClass(this.domNode, "taskLink-selected", select);
        },

        selectionCheck: function() {
            if (this.selected) {
                //   this.getParent().setLink(this);
                this._handleClick();
            }
        },
        
        destroy: function() {
            this.inherited(arguments);
            if (this.textAbbr) {
                this.textAbbr.destroy();
            }
        },

        _handleClick: function(evt) {
            if (this._treeTreeToppersLogger.isFinest()) {
                this._treeTreeToppersLogger.entering("", "_handleClick");
            }

            // call to parent to uncheck all others and then check me
            this.getParent().setLink(this);

            // tell tree I'm in charge
            topic.publish("TREETOPPERINCHARGE", "true"); //tell workarea to switch it up

            var hashObj = this.getUrlHashObj();
            hashObj.treeTopperId = this.topperId;

            // remove the sourcetoken from the hash object, there can be only one
            if (hashObj.sourceToken) {
                delete hashObj.sourceToken;
            }

            dojo.hash(dojo.objectToQuery(hashObj), true); // set

            var retargetInfoObject = {};
            retargetInfoObject[Constants.HASH_TASK_PATH_KEY] = this.taskWidgetPathKey;
            retargetInfoObject[Constants.HASH_TASK_PATH] = this.taskWidgetPath;
            retargetInfoObject[Constants.HASH_TASK_SELECTION] = this.taskWidgetId;
            retargetInfoObject[Constants.COLLECTION] = this.collectionID;
            topic.publish(Constants.TOPIC_RETARGET_INFO, retargetInfoObject); //tell workarea to switch it up

            if (this._treeTreeToppersLogger.isFinest()) {
                this._treeTreeToppersLogger.exiting("", "_handleClick");
            }
        }
    });
});